/* File generated by: simse.codegenerator.enginegenerator.StartingNarrativeDialogGenerator */
package simse.engine;

import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;

public class StartingNarrativeDialog extends JDialog implements ActionListener
{
private JTextArea textArea;
private JButton okButton;

public StartingNarrativeDialog(JFrame owner)
{
super(owner, true);

setTitle("Welcome!");

// Create main panel (box):
Box mainPane = Box.createVerticalBox();
mainPane.setMaximumSize(new Dimension(300, 300));

// Create text area panel:
textArea = new JTextArea(15, 30);
textArea.setLineWrap(true);
textArea.setWrapStyleWord(true);
textArea.setEditable(false);
textArea.setText("Welcome to the SimSE Rapid Prototyping game!\n\nYou have been tasked with building an in-house inventory system for the babycenter.com online baby product store. Your customer is not entirely sure what they want the system to do or to look like, so unearthing their requirements might take a little bit of work and creativity. \n\nSince this is the Rapid Prototyping game, you will, of course, do better in the game if you follow a rapid prototyping process, rather than some other process. The central challenge in this game is doing the right amount of prototyping -- not too little so as to not get enough useful information out of the prototyping process, and not too much so as to waste valuable development time. Not only must you choose how large to build the prototype, but how many cycles to go through of iterative prototype development and subsequent customer evaluation.\n\nNote that a few things are ignored in this game: You have no budget. However, schedule is important, and the customer greatly desires that you deliver the product to them within 825 clock ticks. Reviews and testing are also ignored. You can assume that reviews are part of artifact development and testing is part of implementation. Finally, all employees are assumed to be equally skillful and equally productive.\n\nYour final score will be out of 100 and will be based on how well you use your time, the completeness of the final product (how many requirements you actually implement versus how many the customer had in mind), and the correctness of the final product. You can view these different score components at the end of the game by viewing your project attributes.\n\nOne last note: when we say rapid prototyping, we really mean throw-away prototyping, not evolutionary prototyping (i.e., you should go through a full development process after prototyping is complete. Although in the real world you could use a number of different life cycle models for this, in this particular game, the waterfall model should be used.)\n\nGood luck!" + "");
textArea.setCaretPosition(0);
JScrollPane scrollPane = new JScrollPane(textArea, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
mainPane.add(scrollPane);

// Create okButton pane and button:
JPanel okButtonPane = new JPanel();
okButton = new JButton("OK");
okButton.addActionListener(this);
okButtonPane.add(okButton);
mainPane.add(okButtonPane);

// Set main window frame properties:
setBackground(Color.black);
setContentPane(mainPane);
validate();
pack();
repaint();
toFront();
// Make it show up in the center of the screen:
Point ownerLoc = owner.getLocationOnScreen();
Point thisLoc = new Point();
thisLoc.setLocation((ownerLoc.getX() + (owner.getWidth() / 2) - (this.getWidth() / 2)), (ownerLoc.getY() + (owner.getHeight() / 2) - (this.getHeight() / 2)));
setLocation(thisLoc);
setVisible(true);
}

public void actionPerformed(ActionEvent evt) // handles user actions
{
Object source = evt.getSource();
if(source == okButton)
{
setVisible(false);
dispose();
}
}
}