/* File generated by: simse.codegenerator.explanatorytoolgenerator.ActionInfoPanelGenerator */
package simse.explanatorytool;

import simse.adts.actions.*;
import simse.adts.objects.*;

import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import java.awt.Dimension;
import java.util.Vector;

public class ActionInfoPanel extends JPanel implements ListSelectionListener {
private simse.adts.actions.Action action; // action in focus

private JList triggerList; // for choosing which trigger show
private JList destroyerList; // for choosing which destroyer to show
private JTextArea descriptionArea; // for displaying a trigger/destroyer description
private JTextArea actionDescriptionArea; // for displaying the action description

private final int TRIGGER = 0;
private final int DESTROYER = 1;

public ActionInfoPanel(simse.adts.actions.Action action) {
this.action = action;

// Create main panel (box):
Box mainPane = Box.createVerticalBox();
mainPane.setPreferredSize(new Dimension(900, 550));

// Create actionDescription pane and components:
Box actionDescriptionPane = Box.createVerticalBox();
JPanel actionDescriptionTitlePane = new JPanel();
actionDescriptionTitlePane.add(new JLabel("ActionDescription:"));
actionDescriptionPane.add(actionDescriptionTitlePane);
actionDescriptionArea = new JTextArea(1, 50);
actionDescriptionArea.setLineWrap(true);
actionDescriptionArea.setWrapStyleWord(true);
actionDescriptionArea.setEditable(false);
JScrollPane actionDescriptionScrollPane = new JScrollPane(actionDescriptionArea, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
initializeActionDescription();
actionDescriptionPane.add(actionDescriptionScrollPane);

// Create participants pane and components:
Box participantsPane = Box.createVerticalBox();
JPanel participantsTitlePane = new JPanel();
participantsTitlePane.add(new JLabel("Participants:"));
participantsPane.add(participantsTitlePane);

// participants table:
JScrollPane participantsTablePane = new JScrollPane(createParticipantsTable());
participantsTablePane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
participantsTablePane.setPreferredSize(new Dimension(900, 125));
participantsPane.add(participantsTablePane);

// Create triggerDestroyer pane and components:
JPanel triggerDestroyerPane = new JPanel();

// list pane:
Box listPane = Box.createVerticalBox();

// trigger list:
JPanel triggerListTitlePane = new JPanel();
triggerListTitlePane.add(new JLabel("Triggers:"));
listPane.add(triggerListTitlePane);
triggerList = new JList();
triggerList.setVisibleRowCount(3);
triggerList.setFixedCellWidth(400);
triggerList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
triggerList.addListSelectionListener(this);
initializeTriggerList();
JScrollPane triggerListPane = new JScrollPane(triggerList);
listPane.add(triggerListPane);

// destroyer list:
JPanel destroyerListTitlePane = new JPanel();
destroyerListTitlePane.add(new JLabel("Destroyers:"));
listPane.add(destroyerListTitlePane);
destroyerList = new JList();
destroyerList.setVisibleRowCount(3);
destroyerList.setFixedCellWidth(400);
destroyerList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
destroyerList.addListSelectionListener(this);
initializeDestroyerList();
JScrollPane destroyerListPane = new JScrollPane(destroyerList);
listPane.add(destroyerListPane);

triggerDestroyerPane.add(listPane);

// description pane:
Box descriptionPane = Box.createVerticalBox();
JPanel descriptionTitlePane = new JPanel();
descriptionTitlePane.add(new JLabel("Description:"));
descriptionPane.add(descriptionTitlePane);

// description text area:
descriptionArea = new JTextArea(9, 30);
descriptionArea.setLineWrap(true);
descriptionArea.setWrapStyleWord(true);
descriptionArea.setEditable(false);
JScrollPane descriptionScrollPane = new JScrollPane(descriptionArea, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
descriptionPane.add(descriptionScrollPane);

triggerDestroyerPane.add(descriptionPane);

// Add panes to main pane:
mainPane.add(actionDescriptionPane);
mainPane.add(participantsPane);
mainPane.add(triggerDestroyerPane);
add(mainPane);

// Set main window frame properties:
setOpaque(true);
validate();
repaint();
}

// responds to list selections
public void valueChanged(ListSelectionEvent e) {
if (e.getSource() == triggerList && triggerList.getSelectedIndex() >= 0) {
refreshDescriptionArea(TRIGGER);

// clear selection for destroyer list:
destroyerList.clearSelection();

}
else if (e.getSource() == destroyerList && destroyerList.getSelectedIndex() >= 0) {
refreshDescriptionArea(DESTROYER);

// clear selection for trigger list:
triggerList.clearSelection();
}
}

// initializes the action description
private void initializeActionDescription() {
String text = "";
if (action instanceof OutlineRequirementsWithCustomerAction) {
text = "An initial meeting with the customer to outline the requirements for their software.";
}else if (action instanceof ChoosePrototypingLanguageAction) {
text = "A language to be used for building the prototype is chosen.";
}else if (action instanceof DevelopPrototypeAction) {
text = "The employees build a prototype of the software to be developed.";
}else if (action instanceof HaveCustomerEvaluatePrototypeAction) {
text = "The employees bring the prototype to the customer for their evaluation, to see if it's what they're looking for, and to use as a springboard for discussing more requirements.";
}else if (action instanceof SpecifyRequirementsAction) {
text = "The software engineers create a requirements specification document.";
}else if (action instanceof DesignSystemAction) {
text = "The software engineers design the system.";
}else if (action instanceof ChooseImplementationLanguageAction) {
text = "A language to be used in implementing the system is chosen.";
}else if (action instanceof ImplementSystemAction) {
text = "The software engineers write the code for the system.";
}else if (action instanceof DeliverFinalProductAction) {
text = "The final product is delivered to the customer.";
}else if (action instanceof NotifyCustomerAnxiousForInitialPrototypeAction) {
text = "The customer complains that they've been waiting too long to see the initial prototype.";
}else if (action instanceof NotifyCustomerAnxiousForRevisedPrototypeAction) {
text = "The customer complains that they've waited too long to see the latest revision of the prototype.";
}else if (action instanceof SuggestedRequirementsOutliningPhaseAction) {
text = "Suggested duration of the outlining requirements with customer phase.";
}else if (action instanceof SuggestedPrototypingPhaseAction) {
text = "Suggested duration of the prototyping/customer evaluation phase.";
}else if (action instanceof SuggestedRequirementsPhaseAction) {
text = "Suggested duration of the requirements specification phase.";
}else if (action instanceof SuggestedDesignPhaseAction) {
text = "Suggested duration of the design phase.";
}else if (action instanceof SuggestedImplementationPhaseAction) {
text = "Suggested duration of the implementation phase.";
}actionDescriptionArea.setText(text);
actionDescriptionArea.setCaretPosition(0);
}

// initializes the JList of triggers
private void initializeTriggerList() {
if (action instanceof OutlineRequirementsWithCustomerAction) {
String [] list = {
"TrigA",
};
triggerList.setListData(list);
}
else if (action instanceof ChoosePrototypingLanguageAction) {
String [] list = {
"AutoTrig",
};
triggerList.setListData(list);
}
else if (action instanceof DevelopPrototypeAction) {
String [] list = {
"UserTrig",
};
triggerList.setListData(list);
}
else if (action instanceof HaveCustomerEvaluatePrototypeAction) {
String [] list = {
"UserTrig",
};
triggerList.setListData(list);
}
else if (action instanceof SpecifyRequirementsAction) {
String [] list = {
"UserTrig",
};
triggerList.setListData(list);
}
else if (action instanceof DesignSystemAction) {
String [] list = {
"UserTrig",
};
triggerList.setListData(list);
}
else if (action instanceof ChooseImplementationLanguageAction) {
String [] list = {
"UserTrig",
};
triggerList.setListData(list);
}
else if (action instanceof ImplementSystemAction) {
String [] list = {
"UserTrig",
};
triggerList.setListData(list);
}
else if (action instanceof DeliverFinalProductAction) {
String [] list = {
"UserTrig",
};
triggerList.setListData(list);
}
else if (action instanceof NotifyCustomerAnxiousForInitialPrototypeAction) {
String [] list = {
"AutoTrig",
};
triggerList.setListData(list);
}
else if (action instanceof NotifyCustomerAnxiousForRevisedPrototypeAction) {
String [] list = {
"AutoTrig",
};
triggerList.setListData(list);
}
else if (action instanceof SuggestedRequirementsOutliningPhaseAction) {
String [] list = {
"AutoTrig",
};
triggerList.setListData(list);
}
else if (action instanceof SuggestedPrototypingPhaseAction) {
String [] list = {
"AutoTrig",
};
triggerList.setListData(list);
}
else if (action instanceof SuggestedRequirementsPhaseAction) {
String [] list = {
"AutoTrig",
};
triggerList.setListData(list);
}
else if (action instanceof SuggestedDesignPhaseAction) {
String [] list = {
"AutoTrig",
};
triggerList.setListData(list);
}
else if (action instanceof SuggestedImplementationPhaseAction) {
String [] list = {
"AutoTrig",
};
triggerList.setListData(list);
}
}

// initializes the JList of destroyers
private void initializeDestroyerList() {
if (action instanceof OutlineRequirementsWithCustomerAction) {
String [] list = {
"AutoDest",
};
destroyerList.setListData(list);
}
else if (action instanceof ChoosePrototypingLanguageAction) {
String [] list = {
"TimedDest",
};
destroyerList.setListData(list);
}
else if (action instanceof DevelopPrototypeAction) {
String [] list = {
"UserDest",
"AutoDest",
};
destroyerList.setListData(list);
}
else if (action instanceof HaveCustomerEvaluatePrototypeAction) {
String [] list = {
"UserDest",
"AutoDest",
};
destroyerList.setListData(list);
}
else if (action instanceof SpecifyRequirementsAction) {
String [] list = {
"AutoDest",
"UserDest",
};
destroyerList.setListData(list);
}
else if (action instanceof DesignSystemAction) {
String [] list = {
"AutoDest",
"UserDest",
};
destroyerList.setListData(list);
}
else if (action instanceof ChooseImplementationLanguageAction) {
String [] list = {
"TimedDest",
};
destroyerList.setListData(list);
}
else if (action instanceof ImplementSystemAction) {
String [] list = {
"AutoDest",
"UserDest",
};
destroyerList.setListData(list);
}
else if (action instanceof DeliverFinalProductAction) {
String [] list = {
};
destroyerList.setListData(list);
}
else if (action instanceof NotifyCustomerAnxiousForInitialPrototypeAction) {
String [] list = {
"TimedDest",
};
destroyerList.setListData(list);
}
else if (action instanceof NotifyCustomerAnxiousForRevisedPrototypeAction) {
String [] list = {
"TimedDest",
};
destroyerList.setListData(list);
}
else if (action instanceof SuggestedRequirementsOutliningPhaseAction) {
String [] list = {
"TimedDest",
};
destroyerList.setListData(list);
}
else if (action instanceof SuggestedPrototypingPhaseAction) {
String [] list = {
"TimedDest",
};
destroyerList.setListData(list);
}
else if (action instanceof SuggestedRequirementsPhaseAction) {
String [] list = {
"TimedDest",
};
destroyerList.setListData(list);
}
else if (action instanceof SuggestedDesignPhaseAction) {
String [] list = {
"TimedDest",
};
destroyerList.setListData(list);
}
else if (action instanceof SuggestedImplementationPhaseAction) {
String [] list = {
"TimedDest",
};
destroyerList.setListData(list);
}
}

private JTable createParticipantsTable() {
String[] columnNames = { "Participant Name", "Participant", "Status" };
Object[][] data = new Object[action.getAllParticipants().size()][3];
int index = 0;
if (action instanceof OutlineRequirementsWithCustomerAction) {
OutlineRequirementsWithCustomerAction outlinerequirementswithcustomerAction = (OutlineRequirementsWithCustomerAction)action;

 // RequirementsAnalysts participant:
Vector<Employee> requirementsanalystss = outlinerequirementswithcustomerAction.getAllRequirementsAnalystss();
Vector<Employee> activeRequirementsAnalystss = outlinerequirementswithcustomerAction.getAllActiveRequirementsAnalystss();
for (int i = 0; i < requirementsanalystss.size(); i++) {
Employee requirementsanalysts = requirementsanalystss.get(i);
data[index][0] = "RequirementsAnalysts";
if (requirementsanalysts instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerRequirementsAnalysts = (SoftwareEngineer)requirementsanalysts;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerRequirementsAnalysts.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeRequirementsAnalystss.size(); j++) {
Employee activeRequirementsAnalysts = activeRequirementsAnalystss.get(j);
if ((activeRequirementsAnalysts instanceof SoftwareEngineer) && ((SoftwareEngineer)activeRequirementsAnalysts).getName().equals(((SoftwareEngineer)requirementsanalysts).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // RequirementsDoc participant:
Vector<Artifact> requirementsdocs = outlinerequirementswithcustomerAction.getAllRequirementsDocs();
Vector<Artifact> activeRequirementsDocs = outlinerequirementswithcustomerAction.getAllActiveRequirementsDocs();
for (int i = 0; i < requirementsdocs.size(); i++) {
Artifact requirementsdoc = requirementsdocs.get(i);
data[index][0] = "RequirementsDoc";
if (requirementsdoc instanceof RequirementsDocument) {
RequirementsDocument requirementsdocumentRequirementsDoc = (RequirementsDocument)requirementsdoc;
data[index][1] = "RequirementsDocument Artifact " + requirementsdocumentRequirementsDoc.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeRequirementsDocs.size(); j++) {
Artifact activeRequirementsDoc = activeRequirementsDocs.get(j);
if ((activeRequirementsDoc instanceof RequirementsDocument) && ((RequirementsDocument)activeRequirementsDoc).getName().equals(((RequirementsDocument)requirementsdoc).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // CustomerRep participant:
Vector<Customer> customerreps = outlinerequirementswithcustomerAction.getAllCustomerReps();
Vector<Customer> activeCustomerReps = outlinerequirementswithcustomerAction.getAllActiveCustomerReps();
for (int i = 0; i < customerreps.size(); i++) {
Customer customerrep = customerreps.get(i);
data[index][0] = "CustomerRep";
if (customerrep instanceof TheCustomer) {
TheCustomer thecustomerCustomerRep = (TheCustomer)customerrep;
data[index][1] = "TheCustomer Customer " + thecustomerCustomerRep.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeCustomerReps.size(); j++) {
Customer activeCustomerRep = activeCustomerReps.get(j);
if ((activeCustomerRep instanceof TheCustomer) && ((TheCustomer)activeCustomerRep).getName().equals(((TheCustomer)customerrep).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Proj participant:
Vector<Project> projs = outlinerequirementswithcustomerAction.getAllProjs();
Vector<Project> activeProjs = outlinerequirementswithcustomerAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
else if (action instanceof ChoosePrototypingLanguageAction) {
ChoosePrototypingLanguageAction chooseprototypinglanguageAction = (ChoosePrototypingLanguageAction)action;

 // Emp participant:
Vector<Employee> emps = chooseprototypinglanguageAction.getAllEmps();
Vector<Employee> activeEmps = chooseprototypinglanguageAction.getAllActiveEmps();
for (int i = 0; i < emps.size(); i++) {
Employee emp = emps.get(i);
data[index][0] = "Emp";
if (emp instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerEmp = (SoftwareEngineer)emp;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerEmp.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeEmps.size(); j++) {
Employee activeEmp = activeEmps.get(j);
if ((activeEmp instanceof SoftwareEngineer) && ((SoftwareEngineer)activeEmp).getName().equals(((SoftwareEngineer)emp).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Lang participant:
Vector<Tool> langs = chooseprototypinglanguageAction.getAllLangs();
Vector<Tool> activeLangs = chooseprototypinglanguageAction.getAllActiveLangs();
for (int i = 0; i < langs.size(); i++) {
Tool lang = langs.get(i);
data[index][0] = "Lang";
if (lang instanceof LanguageTool) {
LanguageTool languagetoolLang = (LanguageTool)lang;
data[index][1] = "LanguageTool Tool " + languagetoolLang.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeLangs.size(); j++) {
Tool activeLang = activeLangs.get(j);
if ((activeLang instanceof LanguageTool) && ((LanguageTool)activeLang).getName().equals(((LanguageTool)lang).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Proj participant:
Vector<Project> projs = chooseprototypinglanguageAction.getAllProjs();
Vector<Project> activeProjs = chooseprototypinglanguageAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
else if (action instanceof DevelopPrototypeAction) {
DevelopPrototypeAction developprototypeAction = (DevelopPrototypeAction)action;

 // Developers participant:
Vector<Employee> developerss = developprototypeAction.getAllDeveloperss();
Vector<Employee> activeDeveloperss = developprototypeAction.getAllActiveDeveloperss();
for (int i = 0; i < developerss.size(); i++) {
Employee developers = developerss.get(i);
data[index][0] = "Developers";
if (developers instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerDevelopers = (SoftwareEngineer)developers;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerDevelopers.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeDeveloperss.size(); j++) {
Employee activeDevelopers = activeDeveloperss.get(j);
if ((activeDevelopers instanceof SoftwareEngineer) && ((SoftwareEngineer)activeDevelopers).getName().equals(((SoftwareEngineer)developers).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Prototype participant:
Vector<Artifact> prototypes = developprototypeAction.getAllPrototypes();
Vector<Artifact> activePrototypes = developprototypeAction.getAllActivePrototypes();
for (int i = 0; i < prototypes.size(); i++) {
Artifact prototype = prototypes.get(i);
data[index][0] = "Prototype";
if (prototype instanceof Prototype) {
Prototype prototypePrototype = (Prototype)prototype;
data[index][1] = "Prototype Artifact " + prototypePrototype.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activePrototypes.size(); j++) {
Artifact activePrototype = activePrototypes.get(j);
if ((activePrototype instanceof Prototype) && ((Prototype)activePrototype).getName().equals(((Prototype)prototype).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // RequirementsDoc participant:
Vector<Artifact> requirementsdocs = developprototypeAction.getAllRequirementsDocs();
Vector<Artifact> activeRequirementsDocs = developprototypeAction.getAllActiveRequirementsDocs();
for (int i = 0; i < requirementsdocs.size(); i++) {
Artifact requirementsdoc = requirementsdocs.get(i);
data[index][0] = "RequirementsDoc";
if (requirementsdoc instanceof RequirementsDocument) {
RequirementsDocument requirementsdocumentRequirementsDoc = (RequirementsDocument)requirementsdoc;
data[index][1] = "RequirementsDocument Artifact " + requirementsdocumentRequirementsDoc.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeRequirementsDocs.size(); j++) {
Artifact activeRequirementsDoc = activeRequirementsDocs.get(j);
if ((activeRequirementsDoc instanceof RequirementsDocument) && ((RequirementsDocument)activeRequirementsDoc).getName().equals(((RequirementsDocument)requirementsdoc).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Cust participant:
Vector<Customer> custs = developprototypeAction.getAllCusts();
Vector<Customer> activeCusts = developprototypeAction.getAllActiveCusts();
for (int i = 0; i < custs.size(); i++) {
Customer cust = custs.get(i);
data[index][0] = "Cust";
if (cust instanceof TheCustomer) {
TheCustomer thecustomerCust = (TheCustomer)cust;
data[index][1] = "TheCustomer Customer " + thecustomerCust.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeCusts.size(); j++) {
Customer activeCust = activeCusts.get(j);
if ((activeCust instanceof TheCustomer) && ((TheCustomer)activeCust).getName().equals(((TheCustomer)cust).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Language participant:
Vector<Tool> languages = developprototypeAction.getAllLanguages();
Vector<Tool> activeLanguages = developprototypeAction.getAllActiveLanguages();
for (int i = 0; i < languages.size(); i++) {
Tool language = languages.get(i);
data[index][0] = "Language";
if (language instanceof LanguageTool) {
LanguageTool languagetoolLanguage = (LanguageTool)language;
data[index][1] = "LanguageTool Tool " + languagetoolLanguage.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeLanguages.size(); j++) {
Tool activeLanguage = activeLanguages.get(j);
if ((activeLanguage instanceof LanguageTool) && ((LanguageTool)activeLanguage).getName().equals(((LanguageTool)language).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Proj participant:
Vector<Project> projs = developprototypeAction.getAllProjs();
Vector<Project> activeProjs = developprototypeAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
else if (action instanceof HaveCustomerEvaluatePrototypeAction) {
HaveCustomerEvaluatePrototypeAction havecustomerevaluateprototypeAction = (HaveCustomerEvaluatePrototypeAction)action;

 // EmployeeReps participant:
Vector<Employee> employeerepss = havecustomerevaluateprototypeAction.getAllEmployeeRepss();
Vector<Employee> activeEmployeeRepss = havecustomerevaluateprototypeAction.getAllActiveEmployeeRepss();
for (int i = 0; i < employeerepss.size(); i++) {
Employee employeereps = employeerepss.get(i);
data[index][0] = "EmployeeReps";
if (employeereps instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerEmployeeReps = (SoftwareEngineer)employeereps;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerEmployeeReps.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeEmployeeRepss.size(); j++) {
Employee activeEmployeeReps = activeEmployeeRepss.get(j);
if ((activeEmployeeReps instanceof SoftwareEngineer) && ((SoftwareEngineer)activeEmployeeReps).getName().equals(((SoftwareEngineer)employeereps).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Requirements participant:
Vector<Artifact> requirementss = havecustomerevaluateprototypeAction.getAllRequirementss();
Vector<Artifact> activeRequirementss = havecustomerevaluateprototypeAction.getAllActiveRequirementss();
for (int i = 0; i < requirementss.size(); i++) {
Artifact requirements = requirementss.get(i);
data[index][0] = "Requirements";
if (requirements instanceof RequirementsDocument) {
RequirementsDocument requirementsdocumentRequirements = (RequirementsDocument)requirements;
data[index][1] = "RequirementsDocument Artifact " + requirementsdocumentRequirements.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeRequirementss.size(); j++) {
Artifact activeRequirements = activeRequirementss.get(j);
if ((activeRequirements instanceof RequirementsDocument) && ((RequirementsDocument)activeRequirements).getName().equals(((RequirementsDocument)requirements).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Prototype participant:
Vector<Artifact> prototypes = havecustomerevaluateprototypeAction.getAllPrototypes();
Vector<Artifact> activePrototypes = havecustomerevaluateprototypeAction.getAllActivePrototypes();
for (int i = 0; i < prototypes.size(); i++) {
Artifact prototype = prototypes.get(i);
data[index][0] = "Prototype";
if (prototype instanceof Prototype) {
Prototype prototypePrototype = (Prototype)prototype;
data[index][1] = "Prototype Artifact " + prototypePrototype.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activePrototypes.size(); j++) {
Artifact activePrototype = activePrototypes.get(j);
if ((activePrototype instanceof Prototype) && ((Prototype)activePrototype).getName().equals(((Prototype)prototype).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // CustomerRep participant:
Vector<Customer> customerreps = havecustomerevaluateprototypeAction.getAllCustomerReps();
Vector<Customer> activeCustomerReps = havecustomerevaluateprototypeAction.getAllActiveCustomerReps();
for (int i = 0; i < customerreps.size(); i++) {
Customer customerrep = customerreps.get(i);
data[index][0] = "CustomerRep";
if (customerrep instanceof TheCustomer) {
TheCustomer thecustomerCustomerRep = (TheCustomer)customerrep;
data[index][1] = "TheCustomer Customer " + thecustomerCustomerRep.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeCustomerReps.size(); j++) {
Customer activeCustomerRep = activeCustomerReps.get(j);
if ((activeCustomerRep instanceof TheCustomer) && ((TheCustomer)activeCustomerRep).getName().equals(((TheCustomer)customerrep).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Proj participant:
Vector<Project> projs = havecustomerevaluateprototypeAction.getAllProjs();
Vector<Project> activeProjs = havecustomerevaluateprototypeAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
else if (action instanceof SpecifyRequirementsAction) {
SpecifyRequirementsAction specifyrequirementsAction = (SpecifyRequirementsAction)action;

 // Specifiers participant:
Vector<Employee> specifierss = specifyrequirementsAction.getAllSpecifierss();
Vector<Employee> activeSpecifierss = specifyrequirementsAction.getAllActiveSpecifierss();
for (int i = 0; i < specifierss.size(); i++) {
Employee specifiers = specifierss.get(i);
data[index][0] = "Specifiers";
if (specifiers instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerSpecifiers = (SoftwareEngineer)specifiers;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerSpecifiers.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeSpecifierss.size(); j++) {
Employee activeSpecifiers = activeSpecifierss.get(j);
if ((activeSpecifiers instanceof SoftwareEngineer) && ((SoftwareEngineer)activeSpecifiers).getName().equals(((SoftwareEngineer)specifiers).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // ReqDoc participant:
Vector<Artifact> reqdocs = specifyrequirementsAction.getAllReqDocs();
Vector<Artifact> activeReqDocs = specifyrequirementsAction.getAllActiveReqDocs();
for (int i = 0; i < reqdocs.size(); i++) {
Artifact reqdoc = reqdocs.get(i);
data[index][0] = "ReqDoc";
if (reqdoc instanceof RequirementsDocument) {
RequirementsDocument requirementsdocumentReqDoc = (RequirementsDocument)reqdoc;
data[index][1] = "RequirementsDocument Artifact " + requirementsdocumentReqDoc.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeReqDocs.size(); j++) {
Artifact activeReqDoc = activeReqDocs.get(j);
if ((activeReqDoc instanceof RequirementsDocument) && ((RequirementsDocument)activeReqDoc).getName().equals(((RequirementsDocument)reqdoc).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Proj participant:
Vector<Project> projs = specifyrequirementsAction.getAllProjs();
Vector<Project> activeProjs = specifyrequirementsAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
else if (action instanceof DesignSystemAction) {
DesignSystemAction designsystemAction = (DesignSystemAction)action;

 // Designer participant:
Vector<Employee> designers = designsystemAction.getAllDesigners();
Vector<Employee> activeDesigners = designsystemAction.getAllActiveDesigners();
for (int i = 0; i < designers.size(); i++) {
Employee designer = designers.get(i);
data[index][0] = "Designer";
if (designer instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerDesigner = (SoftwareEngineer)designer;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerDesigner.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeDesigners.size(); j++) {
Employee activeDesigner = activeDesigners.get(j);
if ((activeDesigner instanceof SoftwareEngineer) && ((SoftwareEngineer)activeDesigner).getName().equals(((SoftwareEngineer)designer).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Design participant:
Vector<Artifact> designs = designsystemAction.getAllDesigns();
Vector<Artifact> activeDesigns = designsystemAction.getAllActiveDesigns();
for (int i = 0; i < designs.size(); i++) {
Artifact design = designs.get(i);
data[index][0] = "Design";
if (design instanceof DesignDocument) {
DesignDocument designdocumentDesign = (DesignDocument)design;
data[index][1] = "DesignDocument Artifact " + designdocumentDesign.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeDesigns.size(); j++) {
Artifact activeDesign = activeDesigns.get(j);
if ((activeDesign instanceof DesignDocument) && ((DesignDocument)activeDesign).getName().equals(((DesignDocument)design).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // AssociatedRequirements participant:
Vector<Artifact> associatedrequirementss = designsystemAction.getAllAssociatedRequirementss();
Vector<Artifact> activeAssociatedRequirementss = designsystemAction.getAllActiveAssociatedRequirementss();
for (int i = 0; i < associatedrequirementss.size(); i++) {
Artifact associatedrequirements = associatedrequirementss.get(i);
data[index][0] = "AssociatedRequirements";
if (associatedrequirements instanceof RequirementsDocument) {
RequirementsDocument requirementsdocumentAssociatedRequirements = (RequirementsDocument)associatedrequirements;
data[index][1] = "RequirementsDocument Artifact " + requirementsdocumentAssociatedRequirements.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeAssociatedRequirementss.size(); j++) {
Artifact activeAssociatedRequirements = activeAssociatedRequirementss.get(j);
if ((activeAssociatedRequirements instanceof RequirementsDocument) && ((RequirementsDocument)activeAssociatedRequirements).getName().equals(((RequirementsDocument)associatedrequirements).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Proj participant:
Vector<Project> projs = designsystemAction.getAllProjs();
Vector<Project> activeProjs = designsystemAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Prototype participant:
Vector<Artifact> prototypes = designsystemAction.getAllPrototypes();
Vector<Artifact> activePrototypes = designsystemAction.getAllActivePrototypes();
for (int i = 0; i < prototypes.size(); i++) {
Artifact prototype = prototypes.get(i);
data[index][0] = "Prototype";
if (prototype instanceof Prototype) {
Prototype prototypePrototype = (Prototype)prototype;
data[index][1] = "Prototype Artifact " + prototypePrototype.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activePrototypes.size(); j++) {
Artifact activePrototype = activePrototypes.get(j);
if ((activePrototype instanceof Prototype) && ((Prototype)activePrototype).getName().equals(((Prototype)prototype).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
else if (action instanceof ChooseImplementationLanguageAction) {
ChooseImplementationLanguageAction chooseimplementationlanguageAction = (ChooseImplementationLanguageAction)action;

 // Emp participant:
Vector<Employee> emps = chooseimplementationlanguageAction.getAllEmps();
Vector<Employee> activeEmps = chooseimplementationlanguageAction.getAllActiveEmps();
for (int i = 0; i < emps.size(); i++) {
Employee emp = emps.get(i);
data[index][0] = "Emp";
if (emp instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerEmp = (SoftwareEngineer)emp;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerEmp.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeEmps.size(); j++) {
Employee activeEmp = activeEmps.get(j);
if ((activeEmp instanceof SoftwareEngineer) && ((SoftwareEngineer)activeEmp).getName().equals(((SoftwareEngineer)emp).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Language participant:
Vector<Tool> languages = chooseimplementationlanguageAction.getAllLanguages();
Vector<Tool> activeLanguages = chooseimplementationlanguageAction.getAllActiveLanguages();
for (int i = 0; i < languages.size(); i++) {
Tool language = languages.get(i);
data[index][0] = "Language";
if (language instanceof LanguageTool) {
LanguageTool languagetoolLanguage = (LanguageTool)language;
data[index][1] = "LanguageTool Tool " + languagetoolLanguage.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeLanguages.size(); j++) {
Tool activeLanguage = activeLanguages.get(j);
if ((activeLanguage instanceof LanguageTool) && ((LanguageTool)activeLanguage).getName().equals(((LanguageTool)language).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Proj participant:
Vector<Project> projs = chooseimplementationlanguageAction.getAllProjs();
Vector<Project> activeProjs = chooseimplementationlanguageAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
else if (action instanceof ImplementSystemAction) {
ImplementSystemAction implementsystemAction = (ImplementSystemAction)action;

 // Implementers participant:
Vector<Employee> implementerss = implementsystemAction.getAllImplementerss();
Vector<Employee> activeImplementerss = implementsystemAction.getAllActiveImplementerss();
for (int i = 0; i < implementerss.size(); i++) {
Employee implementers = implementerss.get(i);
data[index][0] = "Implementers";
if (implementers instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerImplementers = (SoftwareEngineer)implementers;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerImplementers.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeImplementerss.size(); j++) {
Employee activeImplementers = activeImplementerss.get(j);
if ((activeImplementers instanceof SoftwareEngineer) && ((SoftwareEngineer)activeImplementers).getName().equals(((SoftwareEngineer)implementers).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Code participant:
Vector<Artifact> codes = implementsystemAction.getAllCodes();
Vector<Artifact> activeCodes = implementsystemAction.getAllActiveCodes();
for (int i = 0; i < codes.size(); i++) {
Artifact code = codes.get(i);
data[index][0] = "Code";
if (code instanceof Code) {
Code codeCode = (Code)code;
data[index][1] = "Code Artifact " + codeCode.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeCodes.size(); j++) {
Artifact activeCode = activeCodes.get(j);
if ((activeCode instanceof Code) && ((Code)activeCode).getName().equals(((Code)code).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // AssociatedRequirements participant:
Vector<Artifact> associatedrequirementss = implementsystemAction.getAllAssociatedRequirementss();
Vector<Artifact> activeAssociatedRequirementss = implementsystemAction.getAllActiveAssociatedRequirementss();
for (int i = 0; i < associatedrequirementss.size(); i++) {
Artifact associatedrequirements = associatedrequirementss.get(i);
data[index][0] = "AssociatedRequirements";
if (associatedrequirements instanceof RequirementsDocument) {
RequirementsDocument requirementsdocumentAssociatedRequirements = (RequirementsDocument)associatedrequirements;
data[index][1] = "RequirementsDocument Artifact " + requirementsdocumentAssociatedRequirements.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeAssociatedRequirementss.size(); j++) {
Artifact activeAssociatedRequirements = activeAssociatedRequirementss.get(j);
if ((activeAssociatedRequirements instanceof RequirementsDocument) && ((RequirementsDocument)activeAssociatedRequirements).getName().equals(((RequirementsDocument)associatedrequirements).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // AssoociatedDesign participant:
Vector<Artifact> assoociateddesigns = implementsystemAction.getAllAssoociatedDesigns();
Vector<Artifact> activeAssoociatedDesigns = implementsystemAction.getAllActiveAssoociatedDesigns();
for (int i = 0; i < assoociateddesigns.size(); i++) {
Artifact assoociateddesign = assoociateddesigns.get(i);
data[index][0] = "AssoociatedDesign";
if (assoociateddesign instanceof DesignDocument) {
DesignDocument designdocumentAssoociatedDesign = (DesignDocument)assoociateddesign;
data[index][1] = "DesignDocument Artifact " + designdocumentAssoociatedDesign.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeAssoociatedDesigns.size(); j++) {
Artifact activeAssoociatedDesign = activeAssoociatedDesigns.get(j);
if ((activeAssoociatedDesign instanceof DesignDocument) && ((DesignDocument)activeAssoociatedDesign).getName().equals(((DesignDocument)assoociateddesign).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Proj participant:
Vector<Project> projs = implementsystemAction.getAllProjs();
Vector<Project> activeProjs = implementsystemAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // ImplementationLang participant:
Vector<Tool> implementationlangs = implementsystemAction.getAllImplementationLangs();
Vector<Tool> activeImplementationLangs = implementsystemAction.getAllActiveImplementationLangs();
for (int i = 0; i < implementationlangs.size(); i++) {
Tool implementationlang = implementationlangs.get(i);
data[index][0] = "ImplementationLang";
if (implementationlang instanceof LanguageTool) {
LanguageTool languagetoolImplementationLang = (LanguageTool)implementationlang;
data[index][1] = "LanguageTool Tool " + languagetoolImplementationLang.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeImplementationLangs.size(); j++) {
Tool activeImplementationLang = activeImplementationLangs.get(j);
if ((activeImplementationLang instanceof LanguageTool) && ((LanguageTool)activeImplementationLang).getName().equals(((LanguageTool)implementationlang).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Prototype participant:
Vector<Artifact> prototypes = implementsystemAction.getAllPrototypes();
Vector<Artifact> activePrototypes = implementsystemAction.getAllActivePrototypes();
for (int i = 0; i < prototypes.size(); i++) {
Artifact prototype = prototypes.get(i);
data[index][0] = "Prototype";
if (prototype instanceof Prototype) {
Prototype prototypePrototype = (Prototype)prototype;
data[index][1] = "Prototype Artifact " + prototypePrototype.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activePrototypes.size(); j++) {
Artifact activePrototype = activePrototypes.get(j);
if ((activePrototype instanceof Prototype) && ((Prototype)activePrototype).getName().equals(((Prototype)prototype).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
else if (action instanceof DeliverFinalProductAction) {
DeliverFinalProductAction deliverfinalproductAction = (DeliverFinalProductAction)action;

 // Emp participant:
Vector<Employee> emps = deliverfinalproductAction.getAllEmps();
Vector<Employee> activeEmps = deliverfinalproductAction.getAllActiveEmps();
for (int i = 0; i < emps.size(); i++) {
Employee emp = emps.get(i);
data[index][0] = "Emp";
if (emp instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerEmp = (SoftwareEngineer)emp;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerEmp.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeEmps.size(); j++) {
Employee activeEmp = activeEmps.get(j);
if ((activeEmp instanceof SoftwareEngineer) && ((SoftwareEngineer)activeEmp).getName().equals(((SoftwareEngineer)emp).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Code participant:
Vector<Artifact> codes = deliverfinalproductAction.getAllCodes();
Vector<Artifact> activeCodes = deliverfinalproductAction.getAllActiveCodes();
for (int i = 0; i < codes.size(); i++) {
Artifact code = codes.get(i);
data[index][0] = "Code";
if (code instanceof Code) {
Code codeCode = (Code)code;
data[index][1] = "Code Artifact " + codeCode.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeCodes.size(); j++) {
Artifact activeCode = activeCodes.get(j);
if ((activeCode instanceof Code) && ((Code)activeCode).getName().equals(((Code)code).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Proj participant:
Vector<Project> projs = deliverfinalproductAction.getAllProjs();
Vector<Project> activeProjs = deliverfinalproductAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Requirements participant:
Vector<Artifact> requirementss = deliverfinalproductAction.getAllRequirementss();
Vector<Artifact> activeRequirementss = deliverfinalproductAction.getAllActiveRequirementss();
for (int i = 0; i < requirementss.size(); i++) {
Artifact requirements = requirementss.get(i);
data[index][0] = "Requirements";
if (requirements instanceof RequirementsDocument) {
RequirementsDocument requirementsdocumentRequirements = (RequirementsDocument)requirements;
data[index][1] = "RequirementsDocument Artifact " + requirementsdocumentRequirements.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeRequirementss.size(); j++) {
Artifact activeRequirements = activeRequirementss.get(j);
if ((activeRequirements instanceof RequirementsDocument) && ((RequirementsDocument)activeRequirements).getName().equals(((RequirementsDocument)requirements).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
else if (action instanceof NotifyCustomerAnxiousForInitialPrototypeAction) {
NotifyCustomerAnxiousForInitialPrototypeAction notifycustomeranxiousforinitialprototypeAction = (NotifyCustomerAnxiousForInitialPrototypeAction)action;

 // Proj participant:
Vector<Project> projs = notifycustomeranxiousforinitialprototypeAction.getAllProjs();
Vector<Project> activeProjs = notifycustomeranxiousforinitialprototypeAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Emp participant:
Vector<Employee> emps = notifycustomeranxiousforinitialprototypeAction.getAllEmps();
Vector<Employee> activeEmps = notifycustomeranxiousforinitialprototypeAction.getAllActiveEmps();
for (int i = 0; i < emps.size(); i++) {
Employee emp = emps.get(i);
data[index][0] = "Emp";
if (emp instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerEmp = (SoftwareEngineer)emp;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerEmp.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeEmps.size(); j++) {
Employee activeEmp = activeEmps.get(j);
if ((activeEmp instanceof SoftwareEngineer) && ((SoftwareEngineer)activeEmp).getName().equals(((SoftwareEngineer)emp).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
else if (action instanceof NotifyCustomerAnxiousForRevisedPrototypeAction) {
NotifyCustomerAnxiousForRevisedPrototypeAction notifycustomeranxiousforrevisedprototypeAction = (NotifyCustomerAnxiousForRevisedPrototypeAction)action;

 // Proj participant:
Vector<Project> projs = notifycustomeranxiousforrevisedprototypeAction.getAllProjs();
Vector<Project> activeProjs = notifycustomeranxiousforrevisedprototypeAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Emp participant:
Vector<Employee> emps = notifycustomeranxiousforrevisedprototypeAction.getAllEmps();
Vector<Employee> activeEmps = notifycustomeranxiousforrevisedprototypeAction.getAllActiveEmps();
for (int i = 0; i < emps.size(); i++) {
Employee emp = emps.get(i);
data[index][0] = "Emp";
if (emp instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerEmp = (SoftwareEngineer)emp;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerEmp.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeEmps.size(); j++) {
Employee activeEmp = activeEmps.get(j);
if ((activeEmp instanceof SoftwareEngineer) && ((SoftwareEngineer)activeEmp).getName().equals(((SoftwareEngineer)emp).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
else if (action instanceof SuggestedRequirementsOutliningPhaseAction) {
SuggestedRequirementsOutliningPhaseAction suggestedrequirementsoutliningphaseAction = (SuggestedRequirementsOutliningPhaseAction)action;

 // Proj participant:
Vector<Project> projs = suggestedrequirementsoutliningphaseAction.getAllProjs();
Vector<Project> activeProjs = suggestedrequirementsoutliningphaseAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Emp participant:
Vector<Employee> emps = suggestedrequirementsoutliningphaseAction.getAllEmps();
Vector<Employee> activeEmps = suggestedrequirementsoutliningphaseAction.getAllActiveEmps();
for (int i = 0; i < emps.size(); i++) {
Employee emp = emps.get(i);
data[index][0] = "Emp";
if (emp instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerEmp = (SoftwareEngineer)emp;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerEmp.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeEmps.size(); j++) {
Employee activeEmp = activeEmps.get(j);
if ((activeEmp instanceof SoftwareEngineer) && ((SoftwareEngineer)activeEmp).getName().equals(((SoftwareEngineer)emp).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
else if (action instanceof SuggestedPrototypingPhaseAction) {
SuggestedPrototypingPhaseAction suggestedprototypingphaseAction = (SuggestedPrototypingPhaseAction)action;

 // Proj participant:
Vector<Project> projs = suggestedprototypingphaseAction.getAllProjs();
Vector<Project> activeProjs = suggestedprototypingphaseAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Emp participant:
Vector<Employee> emps = suggestedprototypingphaseAction.getAllEmps();
Vector<Employee> activeEmps = suggestedprototypingphaseAction.getAllActiveEmps();
for (int i = 0; i < emps.size(); i++) {
Employee emp = emps.get(i);
data[index][0] = "Emp";
if (emp instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerEmp = (SoftwareEngineer)emp;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerEmp.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeEmps.size(); j++) {
Employee activeEmp = activeEmps.get(j);
if ((activeEmp instanceof SoftwareEngineer) && ((SoftwareEngineer)activeEmp).getName().equals(((SoftwareEngineer)emp).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
else if (action instanceof SuggestedRequirementsPhaseAction) {
SuggestedRequirementsPhaseAction suggestedrequirementsphaseAction = (SuggestedRequirementsPhaseAction)action;

 // Proj participant:
Vector<Project> projs = suggestedrequirementsphaseAction.getAllProjs();
Vector<Project> activeProjs = suggestedrequirementsphaseAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Emp participant:
Vector<Employee> emps = suggestedrequirementsphaseAction.getAllEmps();
Vector<Employee> activeEmps = suggestedrequirementsphaseAction.getAllActiveEmps();
for (int i = 0; i < emps.size(); i++) {
Employee emp = emps.get(i);
data[index][0] = "Emp";
if (emp instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerEmp = (SoftwareEngineer)emp;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerEmp.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeEmps.size(); j++) {
Employee activeEmp = activeEmps.get(j);
if ((activeEmp instanceof SoftwareEngineer) && ((SoftwareEngineer)activeEmp).getName().equals(((SoftwareEngineer)emp).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
else if (action instanceof SuggestedDesignPhaseAction) {
SuggestedDesignPhaseAction suggesteddesignphaseAction = (SuggestedDesignPhaseAction)action;

 // Proj participant:
Vector<Project> projs = suggesteddesignphaseAction.getAllProjs();
Vector<Project> activeProjs = suggesteddesignphaseAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Emp participant:
Vector<Employee> emps = suggesteddesignphaseAction.getAllEmps();
Vector<Employee> activeEmps = suggesteddesignphaseAction.getAllActiveEmps();
for (int i = 0; i < emps.size(); i++) {
Employee emp = emps.get(i);
data[index][0] = "Emp";
if (emp instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerEmp = (SoftwareEngineer)emp;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerEmp.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeEmps.size(); j++) {
Employee activeEmp = activeEmps.get(j);
if ((activeEmp instanceof SoftwareEngineer) && ((SoftwareEngineer)activeEmp).getName().equals(((SoftwareEngineer)emp).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
else if (action instanceof SuggestedImplementationPhaseAction) {
SuggestedImplementationPhaseAction suggestedimplementationphaseAction = (SuggestedImplementationPhaseAction)action;

 // Proj participant:
Vector<Project> projs = suggestedimplementationphaseAction.getAllProjs();
Vector<Project> activeProjs = suggestedimplementationphaseAction.getAllActiveProjs();
for (int i = 0; i < projs.size(); i++) {
Project proj = projs.get(i);
data[index][0] = "Proj";
if (proj instanceof TheProject) {
TheProject theprojectProj = (TheProject)proj;
data[index][1] = "TheProject Project " + theprojectProj.getDescription();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeProjs.size(); j++) {
Project activeProj = activeProjs.get(j);
if ((activeProj instanceof TheProject) && ((TheProject)activeProj).getDescription().equals(((TheProject)proj).getDescription())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
 // Emp participant:
Vector<Employee> emps = suggestedimplementationphaseAction.getAllEmps();
Vector<Employee> activeEmps = suggestedimplementationphaseAction.getAllActiveEmps();
for (int i = 0; i < emps.size(); i++) {
Employee emp = emps.get(i);
data[index][0] = "Emp";
if (emp instanceof SoftwareEngineer) {
SoftwareEngineer softwareengineerEmp = (SoftwareEngineer)emp;
data[index][1] = "SoftwareEngineer Employee " + softwareengineerEmp.getName();

// find out whether it's active or not:
boolean active = false;
for (int j = 0; j < activeEmps.size(); j++) {
Employee activeEmp = activeEmps.get(j);
if ((activeEmp instanceof SoftwareEngineer) && ((SoftwareEngineer)activeEmp).getName().equals(((SoftwareEngineer)emp).getName())) {
active = true;
break;
}
}
data[index][2] = active ? "Active" : "Inactive";
}
index++;
}
}
return new JTable(data, columnNames);
}

// refreshes the description area with the selected trigger/destroyer
private void refreshDescriptionArea(int trigOrDest) {
String name = trigOrDest == TRIGGER ? (String) triggerList.getSelectedValue() : (String) destroyerList.getSelectedValue();
if (name != null) {
String text = "";
if (action instanceof OutlineRequirementsWithCustomerAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("TrigA")) {
text = TriggerDescriptions.OUTLINEREQUIREMENTSWITHCUSTOMER_TRIGA;
}
if (trigOrDest == DESTROYER && name.equals("AutoDest")) {
text = DestroyerDescriptions.OUTLINEREQUIREMENTSWITHCUSTOMER_AUTODEST;
}
}
else if (action instanceof ChoosePrototypingLanguageAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("AutoTrig")) {
text = TriggerDescriptions.CHOOSEPROTOTYPINGLANGUAGE_AUTOTRIG;
}
if (trigOrDest == DESTROYER && name.equals("TimedDest")) {
text = DestroyerDescriptions.CHOOSEPROTOTYPINGLANGUAGE_TIMEDDEST;
}
}
else if (action instanceof DevelopPrototypeAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("UserTrig")) {
text = TriggerDescriptions.DEVELOPPROTOTYPE_USERTRIG;
}
if (trigOrDest == DESTROYER && name.equals("UserDest")) {
text = DestroyerDescriptions.DEVELOPPROTOTYPE_USERDEST;
}
else if (trigOrDest == DESTROYER && name.equals("AutoDest")) {
text = DestroyerDescriptions.DEVELOPPROTOTYPE_AUTODEST;
}
}
else if (action instanceof HaveCustomerEvaluatePrototypeAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("UserTrig")) {
text = TriggerDescriptions.HAVECUSTOMEREVALUATEPROTOTYPE_USERTRIG;
}
if (trigOrDest == DESTROYER && name.equals("UserDest")) {
text = DestroyerDescriptions.HAVECUSTOMEREVALUATEPROTOTYPE_USERDEST;
}
else if (trigOrDest == DESTROYER && name.equals("AutoDest")) {
text = DestroyerDescriptions.HAVECUSTOMEREVALUATEPROTOTYPE_AUTODEST;
}
}
else if (action instanceof SpecifyRequirementsAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("UserTrig")) {
text = TriggerDescriptions.SPECIFYREQUIREMENTS_USERTRIG;
}
if (trigOrDest == DESTROYER && name.equals("AutoDest")) {
text = DestroyerDescriptions.SPECIFYREQUIREMENTS_AUTODEST;
}
else if (trigOrDest == DESTROYER && name.equals("UserDest")) {
text = DestroyerDescriptions.SPECIFYREQUIREMENTS_USERDEST;
}
}
else if (action instanceof DesignSystemAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("UserTrig")) {
text = TriggerDescriptions.DESIGNSYSTEM_USERTRIG;
}
if (trigOrDest == DESTROYER && name.equals("AutoDest")) {
text = DestroyerDescriptions.DESIGNSYSTEM_AUTODEST;
}
else if (trigOrDest == DESTROYER && name.equals("UserDest")) {
text = DestroyerDescriptions.DESIGNSYSTEM_USERDEST;
}
}
else if (action instanceof ChooseImplementationLanguageAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("UserTrig")) {
text = TriggerDescriptions.CHOOSEIMPLEMENTATIONLANGUAGE_USERTRIG;
}
if (trigOrDest == DESTROYER && name.equals("TimedDest")) {
text = DestroyerDescriptions.CHOOSEIMPLEMENTATIONLANGUAGE_TIMEDDEST;
}
}
else if (action instanceof ImplementSystemAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("UserTrig")) {
text = TriggerDescriptions.IMPLEMENTSYSTEM_USERTRIG;
}
if (trigOrDest == DESTROYER && name.equals("AutoDest")) {
text = DestroyerDescriptions.IMPLEMENTSYSTEM_AUTODEST;
}
else if (trigOrDest == DESTROYER && name.equals("UserDest")) {
text = DestroyerDescriptions.IMPLEMENTSYSTEM_USERDEST;
}
}
else if (action instanceof DeliverFinalProductAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("UserTrig")) {
text = TriggerDescriptions.DELIVERFINALPRODUCT_USERTRIG;
}
}
else if (action instanceof NotifyCustomerAnxiousForInitialPrototypeAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("AutoTrig")) {
text = TriggerDescriptions.NOTIFYCUSTOMERANXIOUSFORINITIALPROTOTYPE_AUTOTRIG;
}
if (trigOrDest == DESTROYER && name.equals("TimedDest")) {
text = DestroyerDescriptions.NOTIFYCUSTOMERANXIOUSFORINITIALPROTOTYPE_TIMEDDEST;
}
}
else if (action instanceof NotifyCustomerAnxiousForRevisedPrototypeAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("AutoTrig")) {
text = TriggerDescriptions.NOTIFYCUSTOMERANXIOUSFORREVISEDPROTOTYPE_AUTOTRIG;
}
if (trigOrDest == DESTROYER && name.equals("TimedDest")) {
text = DestroyerDescriptions.NOTIFYCUSTOMERANXIOUSFORREVISEDPROTOTYPE_TIMEDDEST;
}
}
else if (action instanceof SuggestedRequirementsOutliningPhaseAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("AutoTrig")) {
text = TriggerDescriptions.SUGGESTEDREQUIREMENTSOUTLININGPHASE_AUTOTRIG;
}
if (trigOrDest == DESTROYER && name.equals("TimedDest")) {
text = DestroyerDescriptions.SUGGESTEDREQUIREMENTSOUTLININGPHASE_TIMEDDEST;
}
}
else if (action instanceof SuggestedPrototypingPhaseAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("AutoTrig")) {
text = TriggerDescriptions.SUGGESTEDPROTOTYPINGPHASE_AUTOTRIG;
}
if (trigOrDest == DESTROYER && name.equals("TimedDest")) {
text = DestroyerDescriptions.SUGGESTEDPROTOTYPINGPHASE_TIMEDDEST;
}
}
else if (action instanceof SuggestedRequirementsPhaseAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("AutoTrig")) {
text = TriggerDescriptions.SUGGESTEDREQUIREMENTSPHASE_AUTOTRIG;
}
if (trigOrDest == DESTROYER && name.equals("TimedDest")) {
text = DestroyerDescriptions.SUGGESTEDREQUIREMENTSPHASE_TIMEDDEST;
}
}
else if (action instanceof SuggestedDesignPhaseAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("AutoTrig")) {
text = TriggerDescriptions.SUGGESTEDDESIGNPHASE_AUTOTRIG;
}
if (trigOrDest == DESTROYER && name.equals("TimedDest")) {
text = DestroyerDescriptions.SUGGESTEDDESIGNPHASE_TIMEDDEST;
}
}
else if (action instanceof SuggestedImplementationPhaseAction) {
// triggers:
if (trigOrDest == TRIGGER && name.equals("AutoTrig")) {
text = TriggerDescriptions.SUGGESTEDIMPLEMENTATIONPHASE_AUTOTRIG;
}
if (trigOrDest == DESTROYER && name.equals("TimedDest")) {
text = DestroyerDescriptions.SUGGESTEDIMPLEMENTATIONPHASE_TIMEDDEST;
}
}
descriptionArea.setText(text);
descriptionArea.setCaretPosition(0);
}
}
}