/* File generated by: simse.codegenerator.explanatorytoolgenerator.ObjectGraphGenerator */
package simse.explanatorytool;

import simse.adts.objects.*;
import simse.state.*;
import simse.state.logger.Logger;
import simse.SimSE;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.ChartRenderingInfo;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.data.Range;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;
import org.jfree.ui.RectangleEdge;
import org.jfree.ui.RectangleInsets;
import org.jfree.ui.RefineryUtilities;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.awt.Point;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;

import javax.swing.JFrame;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JSeparator;

public class ObjectGraph extends JFrame implements MouseListener, ActionListener {
private ArrayList<State> log;
private String objTypeType;
private String objType;
private String keyAttVal;
private String[] attributes;
private JFreeChart chart; // chart object
private ChartPanel chartPanel;
private JMenuItem newBranchItem;
private JSeparator separator;
private int lastRightClickedX; // last x-val that was right-clicked on
private XYSeries[] series;
private Branch branch; // branch from which this graph is generated

public ObjectGraph(String title, ArrayList<State> log, String objTypeType, String objType, String keyAttVal, String[] attributes, boolean showChart, Branch branch) {
super();
this.branch = branch;
if (branch.getName() != null) {
title = title.concat(" - " + branch.getName());
}
setTitle(title);
this.log = log;
this.objTypeType = objTypeType;
this.objType = objType;
this.keyAttVal = keyAttVal;
this.attributes = attributes;
lastRightClickedX = 0;
XYDataset dataset = createDataset();
chart = createChart(dataset);
chartPanel = new ChartPanel(chart);
chartPanel.addMouseListener(this);
chartPanel.setPreferredSize(new java.awt.Dimension(500, 270));
setContentPane(chartPanel);
newBranchItem = new JMenuItem("Start new game from here");
newBranchItem.addActionListener(this);
separator = new JSeparator();
pack();
RefineryUtilities.centerFrameOnScreen(this);
setVisible(showChart);
}

// Creates the dataset for this graph
private XYDataset createDataset() {
series = new XYSeries[attributes.length];
for (int i = 0; i < attributes.length; i++) {
series[i] = new XYSeries(attributes[i]);
}

for (int i = 0; i < log.size(); i++) {
for (int j = 0; j < attributes.length; j++) {
if (objTypeType.equals("Employee") && objType.equals("SoftwareEngineer")) {
SoftwareEngineer softwareengineer = null;
if (keyAttVal.equals("Anne Marie")) {
softwareengineer = log.get(i).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Anne Marie");
}
else if (keyAttVal.equals("Dean")) {
softwareengineer = log.get(i).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Dean");
}
else if (keyAttVal.equals("Emily")) {
softwareengineer = log.get(i).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Emily");
}
else if (keyAttVal.equals("Mollie")) {
softwareengineer = log.get(i).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Mollie");
}
else if (keyAttVal.equals("Rowan")) {
softwareengineer = log.get(i).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Rowan");
}
if (softwareengineer != null) {
}
}
else if (objTypeType.equals("Artifact") && objType.equals("Prototype")) {
Prototype prototype = null;
if (keyAttVal.equals("Prototype")) {
prototype = log.get(i).getArtifactStateRepository().getPrototypeStateRepository().get("Prototype");
}
if (prototype != null) {
if (attributes[j].equals("PercentEvaluated")) {
series[j].add(i, prototype.getPercentEvaluated());
}
else if (attributes[j].equals("PercentDiscoveredRequirementsPrototyped")) {
series[j].add(i, prototype.getPercentDiscoveredRequirementsPrototyped());
}
}
}
else if (objTypeType.equals("Artifact") && objType.equals("RequirementsDocument")) {
RequirementsDocument requirementsdocument = null;
if (keyAttVal.equals("Requirements")) {
requirementsdocument = log.get(i).getArtifactStateRepository().getRequirementsDocumentStateRepository().get("Requirements");
}
if (requirementsdocument != null) {
if (attributes[j].equals("NumRequirementsDiscovered")) {
series[j].add(i, requirementsdocument.getNumRequirementsDiscovered());
}
else if (attributes[j].equals("NumRequirementsNotDiscovered")) {
series[j].add(i, requirementsdocument.getNumRequirementsNotDiscovered());
}
else if (attributes[j].equals("NumRequirementsSpecified")) {
series[j].add(i, requirementsdocument.getNumRequirementsSpecified());
}
else if (attributes[j].equals("PercentComplete")) {
series[j].add(i, requirementsdocument.getPercentComplete());
}
else if (attributes[j].equals("PercentErroneous")) {
series[j].add(i, requirementsdocument.getPercentErroneous());
}
}
}
else if (objTypeType.equals("Artifact") && objType.equals("DesignDocument")) {
DesignDocument designdocument = null;
if (keyAttVal.equals("Design")) {
designdocument = log.get(i).getArtifactStateRepository().getDesignDocumentStateRepository().get("Design");
}
if (designdocument != null) {
if (attributes[j].equals("PercentErroneous")) {
series[j].add(i, designdocument.getPercentErroneous());
}
else if (attributes[j].equals("PercentComplete")) {
series[j].add(i, designdocument.getPercentComplete());
}
}
}
else if (objTypeType.equals("Artifact") && objType.equals("Code")) {
Code code = null;
if (keyAttVal.equals("Code")) {
code = log.get(i).getArtifactStateRepository().getCodeStateRepository().get("Code");
}
if (code != null) {
if (attributes[j].equals("PercentComplete")) {
series[j].add(i, code.getPercentComplete());
}
else if (attributes[j].equals("PercentErroneous")) {
series[j].add(i, code.getPercentErroneous());
}
}
}
else if (objTypeType.equals("Project") && objType.equals("TheProject")) {
TheProject theproject = null;
if (keyAttVal.equals("Inventory system for babycenter.com")) {
theproject = log.get(i).getProjectStateRepository().getTheProjectStateRepository().get("Inventory system for babycenter.com");
}
if (theproject != null) {
if (attributes[j].equals("AllottedTime")) {
series[j].add(i, theproject.getAllottedTime());
}
else if (attributes[j].equals("TimeUsed")) {
series[j].add(i, theproject.getTimeUsed());
}
else if (attributes[j].equals("ProductCompletenessScore")) {
series[j].add(i, theproject.getProductCompletenessScore());
}
else if (attributes[j].equals("ProductCorrectnessScore")) {
series[j].add(i, theproject.getProductCorrectnessScore());
}
else if (attributes[j].equals("ScheduleScore")) {
series[j].add(i, theproject.getScheduleScore());
}
else if (attributes[j].equals("Score")) {
series[j].add(i, theproject.getScore());
}
else if (attributes[j].equals("NumRequirementsTotal")) {
series[j].add(i, theproject.getNumRequirementsTotal());
}
}
}
else if (objTypeType.equals("Tool") && objType.equals("LanguageTool")) {
LanguageTool languagetool = null;
if (keyAttVal.equals("VisualBasic")) {
languagetool = log.get(i).getToolStateRepository().getLanguageToolStateRepository().get("VisualBasic");
}
else if (keyAttVal.equals("Java")) {
languagetool = log.get(i).getToolStateRepository().getLanguageToolStateRepository().get("Java");
}
else if (keyAttVal.equals("C++")) {
languagetool = log.get(i).getToolStateRepository().getLanguageToolStateRepository().get("C++");
}
if (languagetool != null) {
if (attributes[j].equals("PrototypingSpeedModifier")) {
series[j].add(i, languagetool.getPrototypingSpeedModifier());
}
else if (attributes[j].equals("ImplementationSpeedModifier")) {
series[j].add(i, languagetool.getImplementationSpeedModifier());
}
else if (attributes[j].equals("ImplementationErrorModifier")) {
series[j].add(i, languagetool.getImplementationErrorModifier());
}
}
}
else if (objTypeType.equals("Customer") && objType.equals("TheCustomer")) {
TheCustomer thecustomer = null;
if (keyAttVal.equals("babycenter.com")) {
thecustomer = log.get(i).getCustomerStateRepository().getTheCustomerStateRepository().get("babycenter.com");
}
if (thecustomer != null) {
}
}
}
}
XYSeriesCollection dataset = new XYSeriesCollection();
for (int i = 0; i < series.length; i++) {
dataset.addSeries(series[i]);
}
return dataset;
}

// Creates the chart for this graph
private JFreeChart createChart(XYDataset dataset) {
// create the chart:
JFreeChart chart = ChartFactory.createXYLineChart(this.getTitle(), "Clock Ticks", null, dataset, PlotOrientation.VERTICAL, true, true, false);
chart.setBackgroundPaint(Color.white);
XYPlot plot = (XYPlot) chart.getPlot();
plot.setBackgroundPaint(Color.lightGray);
plot.setAxisOffset(new RectangleInsets(5.0, 5.0, 5.0, 5.0));
plot.setDomainGridlinePaint(Color.white);
plot.setRangeGridlinePaint(Color.white);
XYLineAndShapeRenderer renderer = (XYLineAndShapeRenderer) plot.getRenderer();
renderer.setShapesVisible(true);
renderer.setShapesFilled(true);

// change the auto tick unit selection to integer units only:
NumberAxis domainAxis = (NumberAxis) plot.getDomainAxis();
domainAxis.setStandardTickUnits(NumberAxis.createIntegerTickUnits());

return chart;
}

public void update() {
if ((log.size() > 0) && (log.get(log.size() - 1) != null)) { // there is a log that has not been graphed yet
// add a new end data point for each series/attribute
for (int j = 0; j < attributes.length; j++) {
if (objTypeType.equals("Employee") && objType.equals("SoftwareEngineer")) {
SoftwareEngineer softwareengineer = null;
if (keyAttVal.equals("Anne Marie")) {
softwareengineer = log.get(log.size() - 1).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Anne Marie");
}
else if (keyAttVal.equals("Dean")) {
softwareengineer = log.get(log.size() - 1).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Dean");
}
else if (keyAttVal.equals("Emily")) {
softwareengineer = log.get(log.size() - 1).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Emily");
}
else if (keyAttVal.equals("Mollie")) {
softwareengineer = log.get(log.size() - 1).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Mollie");
}
else if (keyAttVal.equals("Rowan")) {
softwareengineer = log.get(log.size() - 1).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Rowan");
}
if (softwareengineer != null) {
}
}
else if (objTypeType.equals("Artifact") && objType.equals("Prototype")) {
Prototype prototype = null;
if (keyAttVal.equals("Prototype")) {
prototype = log.get(log.size() - 1).getArtifactStateRepository().getPrototypeStateRepository().get("Prototype");
}
if (prototype != null) {
if (attributes[j].equals("PercentEvaluated")) {
series[j].add(log.size(), prototype.getPercentEvaluated());
}
else if (attributes[j].equals("PercentDiscoveredRequirementsPrototyped")) {
series[j].add(log.size(), prototype.getPercentDiscoveredRequirementsPrototyped());
}
}
}
else if (objTypeType.equals("Artifact") && objType.equals("RequirementsDocument")) {
RequirementsDocument requirementsdocument = null;
if (keyAttVal.equals("Requirements")) {
requirementsdocument = log.get(log.size() - 1).getArtifactStateRepository().getRequirementsDocumentStateRepository().get("Requirements");
}
if (requirementsdocument != null) {
if (attributes[j].equals("NumRequirementsDiscovered")) {
series[j].add(log.size(), requirementsdocument.getNumRequirementsDiscovered());
}
else if (attributes[j].equals("NumRequirementsNotDiscovered")) {
series[j].add(log.size(), requirementsdocument.getNumRequirementsNotDiscovered());
}
else if (attributes[j].equals("NumRequirementsSpecified")) {
series[j].add(log.size(), requirementsdocument.getNumRequirementsSpecified());
}
else if (attributes[j].equals("PercentComplete")) {
series[j].add(log.size(), requirementsdocument.getPercentComplete());
}
else if (attributes[j].equals("PercentErroneous")) {
series[j].add(log.size(), requirementsdocument.getPercentErroneous());
}
}
}
else if (objTypeType.equals("Artifact") && objType.equals("DesignDocument")) {
DesignDocument designdocument = null;
if (keyAttVal.equals("Design")) {
designdocument = log.get(log.size() - 1).getArtifactStateRepository().getDesignDocumentStateRepository().get("Design");
}
if (designdocument != null) {
if (attributes[j].equals("PercentErroneous")) {
series[j].add(log.size(), designdocument.getPercentErroneous());
}
else if (attributes[j].equals("PercentComplete")) {
series[j].add(log.size(), designdocument.getPercentComplete());
}
}
}
else if (objTypeType.equals("Artifact") && objType.equals("Code")) {
Code code = null;
if (keyAttVal.equals("Code")) {
code = log.get(log.size() - 1).getArtifactStateRepository().getCodeStateRepository().get("Code");
}
if (code != null) {
if (attributes[j].equals("PercentComplete")) {
series[j].add(log.size(), code.getPercentComplete());
}
else if (attributes[j].equals("PercentErroneous")) {
series[j].add(log.size(), code.getPercentErroneous());
}
}
}
else if (objTypeType.equals("Project") && objType.equals("TheProject")) {
TheProject theproject = null;
if (keyAttVal.equals("Inventory system for babycenter.com")) {
theproject = log.get(log.size() - 1).getProjectStateRepository().getTheProjectStateRepository().get("Inventory system for babycenter.com");
}
if (theproject != null) {
if (attributes[j].equals("AllottedTime")) {
series[j].add(log.size(), theproject.getAllottedTime());
}
else if (attributes[j].equals("TimeUsed")) {
series[j].add(log.size(), theproject.getTimeUsed());
}
else if (attributes[j].equals("ProductCompletenessScore")) {
series[j].add(log.size(), theproject.getProductCompletenessScore());
}
else if (attributes[j].equals("ProductCorrectnessScore")) {
series[j].add(log.size(), theproject.getProductCorrectnessScore());
}
else if (attributes[j].equals("ScheduleScore")) {
series[j].add(log.size(), theproject.getScheduleScore());
}
else if (attributes[j].equals("Score")) {
series[j].add(log.size(), theproject.getScore());
}
else if (attributes[j].equals("NumRequirementsTotal")) {
series[j].add(log.size(), theproject.getNumRequirementsTotal());
}
}
}
else if (objTypeType.equals("Tool") && objType.equals("LanguageTool")) {
LanguageTool languagetool = null;
if (keyAttVal.equals("VisualBasic")) {
languagetool = log.get(log.size() - 1).getToolStateRepository().getLanguageToolStateRepository().get("VisualBasic");
}
else if (keyAttVal.equals("Java")) {
languagetool = log.get(log.size() - 1).getToolStateRepository().getLanguageToolStateRepository().get("Java");
}
else if (keyAttVal.equals("C++")) {
languagetool = log.get(log.size() - 1).getToolStateRepository().getLanguageToolStateRepository().get("C++");
}
if (languagetool != null) {
if (attributes[j].equals("PrototypingSpeedModifier")) {
series[j].add(log.size(), languagetool.getPrototypingSpeedModifier());
}
else if (attributes[j].equals("ImplementationSpeedModifier")) {
series[j].add(log.size(), languagetool.getImplementationSpeedModifier());
}
else if (attributes[j].equals("ImplementationErrorModifier")) {
series[j].add(log.size(), languagetool.getImplementationErrorModifier());
}
}
}
else if (objTypeType.equals("Customer") && objType.equals("TheCustomer")) {
TheCustomer thecustomer = null;
if (keyAttVal.equals("babycenter.com")) {
thecustomer = log.get(log.size() - 1).getCustomerStateRepository().getTheCustomerStateRepository().get("babycenter.com");
}
if (thecustomer != null) {
}
}
}
}
}

// responds to RIGHT-clicks on the chart
public void mouseReleased(MouseEvent me) {
if (me.getButton() != MouseEvent.BUTTON1) { // not left-click
XYPlot plot = chart.getXYPlot();
Range domainRange = plot.getDataRange(plot.getDomainAxis());
if (domainRange != null) { // chart is not blank
Point2D pt = chartPanel.translateScreenToJava2D(new Point(me.getX(), me.getY()));
ChartRenderingInfo info = this.chartPanel.getChartRenderingInfo();
Rectangle2D dataArea = info.getPlotInfo().getDataArea();
NumberAxis domainAxis = (NumberAxis)plot.getDomainAxis();
RectangleEdge domainAxisEdge = plot.getDomainAxisEdge();
double chartX = domainAxis.java2DToValue(pt.getX(), dataArea, domainAxisEdge);
lastRightClickedX = (int)Math.rint(chartX);
if (domainRange != null && lastRightClickedX >= domainRange.getLowerBound() && lastRightClickedX <= (domainRange.getUpperBound() - 1) && lastRightClickedX >= 0) { // clicked within domain range
if (chartPanel.getPopupMenu().getComponentIndex(newBranchItem) == -1) { // no new branch item on menu currently
chartPanel.getPopupMenu().add(separator);
chartPanel.getPopupMenu().add(newBranchItem);
chartPanel.getPopupMenu().pack();
chartPanel.getPopupMenu().repaint();
}
}
else { // clicked outside of domain range
if (chartPanel.getPopupMenu().getComponentIndex(newBranchItem) >= 0) { // new branch item currently on menu
chartPanel.getPopupMenu().remove(newBranchItem);
if (chartPanel.getPopupMenu().getComponentIndex(separator) >= 0) { // has separator
chartPanel.getPopupMenu().remove(separator);
}
chartPanel.getPopupMenu().pack();
chartPanel.getPopupMenu().repaint();
}
}
}
}
}
public void mousePressed(MouseEvent me) {}
public void mouseClicked(MouseEvent me) {}
public void mouseEntered(MouseEvent me) {}
public void mouseExited(MouseEvent me) {}

public void actionPerformed(ActionEvent evt) {
if (evt.getSource() == newBranchItem) {
String newBranchName = JOptionPane.showInputDialog(null, "Please name this new game:", "Name New Game", JOptionPane.QUESTION_MESSAGE);
if (newBranchName != null) {
State tempState = (State)log.get(lastRightClickedX).clone();
Logger tempLogger = new Logger(tempState, new ArrayList<State>(log.subList(0, lastRightClickedX)));
Clock tempClock = new Clock(tempLogger, lastRightClickedX);
tempState.setClock(tempClock);
tempState.setLogger(tempLogger);
SimSE.startNewBranch(tempState, new Branch(newBranchName, lastRightClickedX, tempClock.getTime(), branch, null));
}
}
}

public XYPlot getXYPlot() {
return chart.getXYPlot();
}

public String getChartTitle() {
return this.getTitle();
}

public ArrayList<State> getLog() {
return log;
}

public class ExitListener extends WindowAdapter {
public void windowClosing(WindowEvent event) {
setVisible(false);
dispose();
}
}
}