/* File generated by: simse.codegenerator.guigenerator.AtAGlanceFramesGenerator */
package simse.gui;

import simse.state.*;

import java.awt.event.*;
import java.awt.*;
import java.awt.Dimension;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.border.*;
import java.util.*;
import java.text.*;
import java.awt.Color;

public class ArtifactsAtAGlanceFrame extends JFrame implements MouseListener, ActionListener
{

private State state;

private JPopupMenu popup;
private PopupListener popupListener;
private JTable prototypeTable;
private PrototypeTableModel prototypeModel;
private JPanel prototypeTitlePane;
private JTable requirementsdocumentTable;
private RequirementsDocumentTableModel requirementsdocumentModel;
private JPanel requirementsdocumentTitlePane;
private JTable designdocumentTable;
private DesignDocumentTableModel designdocumentModel;
private JPanel designdocumentTitlePane;
private JTable codeTable;
private CodeTableModel codeModel;
private JPanel codeTitlePane;
private JPanel mainPane;

private int realColumnIndex; // index of selected column
private JTable selectedTable; // selected table

public ArtifactsAtAGlanceFrame(State s,SimSEGUI gui)
{
state = s;
// Set window title:
setTitle("Artifacts At-A-Glance");

// Create tables:
int numCols;

prototypeModel = new PrototypeTableModel(s);
prototypeTable = new JTable(prototypeModel);
prototypeTable.setColumnSelectionAllowed(false);
prototypeTable.setRowSelectionAllowed(false);
prototypeTable.addMouseListener(this);
prototypeTable.getTableHeader().setReorderingAllowed(false);
// make it so that the user can make each column disappear if they want:
numCols = prototypeTable.getColumnCount();
for(int i=0; i<numCols; i++)
{
prototypeTable.getColumnModel().getColumn(i).setMinWidth(0);
}
requirementsdocumentModel = new RequirementsDocumentTableModel(s);
requirementsdocumentTable = new JTable(requirementsdocumentModel);
requirementsdocumentTable.setColumnSelectionAllowed(false);
requirementsdocumentTable.setRowSelectionAllowed(false);
requirementsdocumentTable.addMouseListener(this);
requirementsdocumentTable.getTableHeader().setReorderingAllowed(false);
// make it so that the user can make each column disappear if they want:
numCols = requirementsdocumentTable.getColumnCount();
for(int i=0; i<numCols; i++)
{
requirementsdocumentTable.getColumnModel().getColumn(i).setMinWidth(0);
}
designdocumentModel = new DesignDocumentTableModel(s);
designdocumentTable = new JTable(designdocumentModel);
designdocumentTable.setColumnSelectionAllowed(false);
designdocumentTable.setRowSelectionAllowed(false);
designdocumentTable.addMouseListener(this);
designdocumentTable.getTableHeader().setReorderingAllowed(false);
// make it so that the user can make each column disappear if they want:
numCols = designdocumentTable.getColumnCount();
for(int i=0; i<numCols; i++)
{
designdocumentTable.getColumnModel().getColumn(i).setMinWidth(0);
}
codeModel = new CodeTableModel(s);
codeTable = new JTable(codeModel);
codeTable.setColumnSelectionAllowed(false);
codeTable.setRowSelectionAllowed(false);
codeTable.addMouseListener(this);
codeTable.getTableHeader().setReorderingAllowed(false);
// make it so that the user can make each column disappear if they want:
numCols = codeTable.getColumnCount();
for(int i=0; i<numCols; i++)
{
codeTable.getColumnModel().getColumn(i).setMinWidth(0);
}

// right click menu:
popup = new JPopupMenu();
popupListener = new PopupListener(popup,gui);

// Create panes:
JScrollPane prototypePane = new JScrollPane(prototypeTable);
JScrollPane requirementsdocumentPane = new JScrollPane(requirementsdocumentTable);
JScrollPane designdocumentPane = new JScrollPane(designdocumentTable);
JScrollPane codePane = new JScrollPane(codeTable);

// Table headers:
prototypeTitlePane = new JPanel();
prototypeTitlePane.add(new JLabel("Prototypes:"));
requirementsdocumentTitlePane = new JPanel();
requirementsdocumentTitlePane.add(new JLabel("RequirementsDocuments:"));
designdocumentTitlePane = new JPanel();
designdocumentTitlePane.add(new JLabel("DesignDocuments:"));
codeTitlePane = new JPanel();
codeTitlePane.add(new JLabel("Codes:"));

// Create main pane:
mainPane = new JPanel();
mainPane.setLayout(new BoxLayout(mainPane, BoxLayout.Y_AXIS));

// Add panes to main pane:
mainPane.add(prototypeTitlePane);
mainPane.add(prototypePane);
mainPane.add(requirementsdocumentTitlePane);
mainPane.add(requirementsdocumentPane);
mainPane.add(designdocumentTitlePane);
mainPane.add(designdocumentPane);
mainPane.add(codeTitlePane);
mainPane.add(codePane);

// Set main window frame properties:
setBackground(Color.white);
setContentPane(mainPane);
setVisible(false);
pack();
validate();

resetHeight();
}


public void mousePressed(MouseEvent me){}
public void mouseClicked(MouseEvent me){}
public void mouseEntered(MouseEvent me){}
public void mouseExited(MouseEvent me){}

public void mouseReleased(MouseEvent me)
{
Point p = me.getPoint();

if(me.isPopupTrigger())
{
if(me.getComponent().equals(prototypeTable)) // correct table
{
createPopupMenu(prototypeTable, p);
}
else if(me.getComponent().equals(requirementsdocumentTable)) // correct table
{
createPopupMenu(requirementsdocumentTable, p);
}
else if(me.getComponent().equals(designdocumentTable)) // correct table
{
createPopupMenu(designdocumentTable, p);
}
else if(me.getComponent().equals(codeTable)) // correct table
{
createPopupMenu(codeTable, p);
}
}
}


public void actionPerformed(ActionEvent e)	// dealing with actions generated by popup menus
{
Object source = e.getSource();
if(source instanceof JMenuItem)
{
String itemText = ((JMenuItem)source).getText();
if(itemText.equals("Hide"))
{
if(selectedTable != null)
{
selectedTable.getColumnModel().getColumn(realColumnIndex).setMaxWidth(0);
}
}
else // an item on the "Unhide" menu
{
if(selectedTable != null)
{
TableModel model = selectedTable.getModel();
TableColumn column = null;
if(model instanceof PrototypeTableModel)
{
column = selectedTable.getColumnModel().getColumn(((PrototypeTableModel)selectedTable.getModel()).getColumnIndex(itemText));
}
else if(model instanceof RequirementsDocumentTableModel)
{
column = selectedTable.getColumnModel().getColumn(((RequirementsDocumentTableModel)selectedTable.getModel()).getColumnIndex(itemText));
}
else if(model instanceof DesignDocumentTableModel)
{
column = selectedTable.getColumnModel().getColumn(((DesignDocumentTableModel)selectedTable.getModel()).getColumnIndex(itemText));
}
else if(model instanceof CodeTableModel)
{
column = selectedTable.getColumnModel().getColumn(((CodeTableModel)selectedTable.getModel()).getColumnIndex(itemText));
}
if(column != null)
{
column.setMinWidth(0);
column.setMaxWidth(2147483647);
column.setPreferredWidth(selectedTable.getWidth() / (selectedTable.getColumnCount() - getAllHiddenColumnIndices(selectedTable).size() + 1));
}
}
}
}
}


public void createPopupMenu(JTable table, Point p)
{
popup.removeAll();

int colIndex = table.columnAtPoint(p);
realColumnIndex = table.convertColumnIndexToModel(colIndex);

Vector<Integer> hiddenCols = getAllHiddenColumnIndices(table);

if((realColumnIndex >= 0) || (hiddenCols.size() > 0)) // user clicked on a column and/or there is at least one hidden column
{
if(realColumnIndex >= 0)
{
JMenuItem hideItem = new JMenuItem("Hide");
hideItem.addActionListener(this);
popup.add(hideItem);
}

if(hiddenCols.size() > 0) // there is at least one hidden column
{
JMenu unhideMenu = new JMenu("Unhide");
for(int i=0; i<hiddenCols.size(); i++)
{
int index = hiddenCols.elementAt(i).intValue();
JMenuItem tempItem = new JMenuItem(table.getColumnName(index));
tempItem.addActionListener(this);
unhideMenu.add(tempItem);
}
if(popup.getComponents().length > 0) // already has the hide menu item
{
popup.addSeparator();
}
popup.add(unhideMenu);
}

addMouseListener(popupListener);
popup.show(table, (int)p.getX(), (int)p.getY());
selectedTable = table;
repaint();
}
}


public void update()
{
DefaultTableCellRenderer rightAlignRenderer = new DefaultTableCellRenderer();
rightAlignRenderer.setHorizontalAlignment(JLabel.RIGHT);
prototypeModel.update();
if (!state.getClock().isStopped()) { // game not over
prototypeTable.getColumnModel().getColumn(prototypeModel.getColumnIndex("PercentEvaluated")).setCellRenderer(rightAlignRenderer);
prototypeTable.getColumnModel().getColumn(prototypeModel.getColumnIndex("PercentDiscoveredRequirementsPrototyped")).setCellRenderer(rightAlignRenderer);
}
else { // game over
prototypeTable.getColumnModel().getColumn(prototypeModel.getColumnIndex("PercentEvaluated")).setCellRenderer(rightAlignRenderer);
prototypeTable.getColumnModel().getColumn(prototypeModel.getColumnIndex("PercentDiscoveredRequirementsPrototyped")).setCellRenderer(rightAlignRenderer);
}
prototypeTable.update(prototypeTable.getGraphics());
requirementsdocumentModel.update();
if (!state.getClock().isStopped()) { // game not over
requirementsdocumentTable.getColumnModel().getColumn(requirementsdocumentModel.getColumnIndex("NumRequirementsDiscovered")).setCellRenderer(rightAlignRenderer);
requirementsdocumentTable.getColumnModel().getColumn(requirementsdocumentModel.getColumnIndex("NumRequirementsSpecified")).setCellRenderer(rightAlignRenderer);
requirementsdocumentTable.getColumnModel().getColumn(requirementsdocumentModel.getColumnIndex("PercentComplete")).setCellRenderer(rightAlignRenderer);
requirementsdocumentTable.getColumnModel().getColumn(requirementsdocumentModel.getColumnIndex("PercentErroneous")).setCellRenderer(rightAlignRenderer);
}
else { // game over
requirementsdocumentTable.getColumnModel().getColumn(requirementsdocumentModel.getColumnIndex("NumRequirementsDiscovered")).setCellRenderer(rightAlignRenderer);
requirementsdocumentTable.getColumnModel().getColumn(requirementsdocumentModel.getColumnIndex("NumRequirementsNotDiscovered")).setCellRenderer(rightAlignRenderer);
requirementsdocumentTable.getColumnModel().getColumn(requirementsdocumentModel.getColumnIndex("NumRequirementsSpecified")).setCellRenderer(rightAlignRenderer);
requirementsdocumentTable.getColumnModel().getColumn(requirementsdocumentModel.getColumnIndex("PercentComplete")).setCellRenderer(rightAlignRenderer);
requirementsdocumentTable.getColumnModel().getColumn(requirementsdocumentModel.getColumnIndex("PercentErroneous")).setCellRenderer(rightAlignRenderer);
}
requirementsdocumentTable.update(requirementsdocumentTable.getGraphics());
designdocumentModel.update();
if (!state.getClock().isStopped()) { // game not over
designdocumentTable.getColumnModel().getColumn(designdocumentModel.getColumnIndex("PercentErroneous")).setCellRenderer(rightAlignRenderer);
designdocumentTable.getColumnModel().getColumn(designdocumentModel.getColumnIndex("PercentComplete")).setCellRenderer(rightAlignRenderer);
}
else { // game over
designdocumentTable.getColumnModel().getColumn(designdocumentModel.getColumnIndex("PercentErroneous")).setCellRenderer(rightAlignRenderer);
designdocumentTable.getColumnModel().getColumn(designdocumentModel.getColumnIndex("PercentComplete")).setCellRenderer(rightAlignRenderer);
}
designdocumentTable.update(designdocumentTable.getGraphics());
codeModel.update();
if (!state.getClock().isStopped()) { // game not over
codeTable.getColumnModel().getColumn(codeModel.getColumnIndex("PercentComplete")).setCellRenderer(rightAlignRenderer);
codeTable.getColumnModel().getColumn(codeModel.getColumnIndex("PercentErroneous")).setCellRenderer(rightAlignRenderer);
}
else { // game over
codeTable.getColumnModel().getColumn(codeModel.getColumnIndex("PercentComplete")).setCellRenderer(rightAlignRenderer);
codeTable.getColumnModel().getColumn(codeModel.getColumnIndex("PercentErroneous")).setCellRenderer(rightAlignRenderer);
}
codeTable.update(codeTable.getGraphics());
resetHeight();
}
private void resetHeight()
{
// Set appropriate height:
double height = 0;
height += ((prototypeTable.getRowHeight() + (prototypeTable.getRowMargin() * 2)) * (prototypeTable.getRowCount() + 1));
height += prototypeTitlePane.getSize().getHeight();
height += ((requirementsdocumentTable.getRowHeight() + (requirementsdocumentTable.getRowMargin() * 2)) * (requirementsdocumentTable.getRowCount() + 1));
height += requirementsdocumentTitlePane.getSize().getHeight();
height += ((designdocumentTable.getRowHeight() + (designdocumentTable.getRowMargin() * 2)) * (designdocumentTable.getRowCount() + 1));
height += designdocumentTitlePane.getSize().getHeight();
height += ((codeTable.getRowHeight() + (codeTable.getRowMargin() * 2)) * (codeTable.getRowCount() + 1));
height += codeTitlePane.getSize().getHeight();

mainPane.setPreferredSize(new Dimension((int)(mainPane.getSize().getWidth()), (int)height));
pack();
validate();
repaint();
}



private Vector<Integer> getAllHiddenColumnIndices(JTable table)
{
Vector<Integer> hiddenCols = new Vector<Integer>();
int numCols = table.getColumnModel().getColumnCount();
for(int i=0; i<numCols; i++)
{
TableColumn col = table.getColumnModel().getColumn(i);
if(col.getWidth() == 0) // hidden
{
hiddenCols.add(new Integer(i));
}
}
return hiddenCols;
}
}