/* File generated by: simse.codegenerator.logicgenerator.dialoggenerator.EmployeeParticipantSelectionDialogGenerator */
package simse.logic.dialogs;
import simse.gui.ImageLoader;
import simse.gui.TabPanel;
import simse.state.*;
import simse.adts.objects.*;
import simse.adts.actions.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
public class EmployeeParticipantSelectionDialog extends JDialog implements ActionListener
{
private String partName;
private Vector<SSObject> participants;
private simse.adts.actions.Action action;
private State state;
private Employee selectedEmp;
private int minNumParts;
private int maxNumParts;
private Vector<JCheckBox> checkBoxes;
private JButton checkAllButton;
private JButton clearAllButton;
private JButton okButton;
private JButton cancelButton;
private boolean actionCancelled;
public EmployeeParticipantSelectionDialog(JFrame owner, String pName, Vector<SSObject> parts, simse.adts.actions.Action act, State s, Employee emp)
{
super(owner, true);
partName = pName;
participants = parts;
action = act;
state = s;
selectedEmp = emp;
actionCancelled = false;
setMinAndMax();
if(((selectedEmp != null) && (maxNumParts > 0) && (participants.size() > 0)) || ((selectedEmp == null) && (participants.size() > minNumParts)))
{
checkBoxes = new Vector<JCheckBox>();
setTitle("Participant Selection");
Box mainPane = Box.createVerticalBox();
JPanel topPane = new JPanel();
String title = "Choose ";
if(selectedEmp != null) // selected emp already added in this participant role
{
title = title.concat("other ");
}
title = title.concat(partName + " participant(s) (");
if(minNumParts == maxNumParts)
{
title = title.concat("exactly " + minNumParts);
}
else
{
title = title.concat("at least " + minNumParts);
if(maxNumParts < 999999) // not boundless
{
title = title.concat(", at most " + maxNumParts);
}
}
title = title.concat("):");
topPane.add(new JLabel(title));
JPanel middlePane = new JPanel(new GridLayout(0, 1));
for(int i=0; i<participants.size(); i++)
{
SSObject tempObj = participants.elementAt(i);
String label = new String();
if(tempObj instanceof SoftwareEngineer)
{
label = ("SoftwareEngineer (" + ((SoftwareEngineer)tempObj).getName() + ")");
}
else if(tempObj instanceof Prototype)
{
label = ("Prototype (" + ((Prototype)tempObj).getName() + ")");
}
else if(tempObj instanceof RequirementsDocument)
{
label = ("RequirementsDocument (" + ((RequirementsDocument)tempObj).getName() + ")");
}
else if(tempObj instanceof DesignDocument)
{
label = ("DesignDocument (" + ((DesignDocument)tempObj).getName() + ")");
}
else if(tempObj instanceof Code)
{
label = ("Code (" + ((Code)tempObj).getName() + ")");
}
else if(tempObj instanceof TheProject)
{
label = ("TheProject (" + ((TheProject)tempObj).getDescription() + ")");
}
else if(tempObj instanceof LanguageTool)
{
label = ("LanguageTool (" + ((LanguageTool)tempObj).getName() + ")");
}
else if(tempObj instanceof TheCustomer)
{
label = ("TheCustomer (" + ((TheCustomer)tempObj).getName() + ")");
}
JPanel tempPane = new JPanel(new BorderLayout());
JCheckBox tempCheckBox = new JCheckBox(label);
tempPane.add(tempCheckBox, BorderLayout.WEST);
checkBoxes.add(tempCheckBox);
ImageIcon icon =  new ImageIcon(ImageLoader.getImageFromURL(TabPanel.getImage(tempObj)).getScaledInstance(30, 30, Image.SCALE_AREA_AVERAGING));
tempPane.add(new JLabel(icon), BorderLayout.EAST);
middlePane.add(tempPane);
}
JPanel checkPane = new JPanel();
checkAllButton = new JButton("Check All");
checkAllButton.addActionListener(this);
checkPane.add(checkAllButton);
clearAllButton = new JButton("Clear All");
clearAllButton.addActionListener(this);
checkPane.add(clearAllButton);
JPanel bottomPane = new JPanel();
okButton = new JButton("OK");
okButton.addActionListener(this);
bottomPane.add(okButton);
cancelButton = new JButton("Cancel");
cancelButton.addActionListener(this);
bottomPane.add(cancelButton);
mainPane.add(topPane);
mainPane.add(middlePane);
JSeparator separator1 = new JSeparator();
separator1.setMaximumSize(new Dimension(900, 1));
mainPane.add(separator1);
mainPane.add(checkPane);
JSeparator separator2 = new JSeparator();
separator2.setMaximumSize(new Dimension(900, 1));
mainPane.add(separator2);
mainPane.add(bottomPane);
addWindowListener(new ExitListener());
setContentPane(mainPane);
validate();
pack();
repaint();
toFront();
Point ownerLoc = owner.getLocationOnScreen();
Point thisLoc = new Point();
thisLoc.setLocation((ownerLoc.getX() + (owner.getWidth() / 2) - (this.getWidth() / 2)), (ownerLoc.getY() + (owner.getHeight() / 2) - (this.getHeight() / 2)));
setLocation(thisLoc);
setVisible(true);
}
else if ((selectedEmp == null) && (participants.size() == minNumParts)) {
for (int i = 0; i < participants.size(); i++) {
Employee tempEmp = (Employee) participants.elementAt(i);
if(action instanceof OutlineRequirementsWithCustomerAction)
{
if(partName.equals("RequirementsAnalysts"))
{
((OutlineRequirementsWithCustomerAction)action).addRequirementsAnalysts(tempEmp);
}
}
else if(action instanceof ChoosePrototypingLanguageAction)
{
if(partName.equals("Emp"))
{
((ChoosePrototypingLanguageAction)action).addEmp(tempEmp);
}
}
else if(action instanceof DevelopPrototypeAction)
{
if(partName.equals("Developers"))
{
((DevelopPrototypeAction)action).addDevelopers(tempEmp);
}
}
else if(action instanceof HaveCustomerEvaluatePrototypeAction)
{
if(partName.equals("EmployeeReps"))
{
((HaveCustomerEvaluatePrototypeAction)action).addEmployeeReps(tempEmp);
}
}
else if(action instanceof SpecifyRequirementsAction)
{
if(partName.equals("Specifiers"))
{
((SpecifyRequirementsAction)action).addSpecifiers(tempEmp);
}
}
else if(action instanceof DesignSystemAction)
{
if(partName.equals("Designer"))
{
((DesignSystemAction)action).addDesigner(tempEmp);
}
}
else if(action instanceof ChooseImplementationLanguageAction)
{
if(partName.equals("Emp"))
{
((ChooseImplementationLanguageAction)action).addEmp(tempEmp);
}
}
else if(action instanceof ImplementSystemAction)
{
if(partName.equals("Implementers"))
{
((ImplementSystemAction)action).addImplementers(tempEmp);
}
}
else if(action instanceof DeliverFinalProductAction)
{
if(partName.equals("Emp"))
{
((DeliverFinalProductAction)action).addEmp(tempEmp);
}
}
}
}if(selectedEmp != null)
{
if(action instanceof OutlineRequirementsWithCustomerAction)
{
if(partName.equals("RequirementsAnalysts"))
{
((OutlineRequirementsWithCustomerAction)action).addRequirementsAnalysts(selectedEmp);
}
}
else if(action instanceof ChoosePrototypingLanguageAction)
{
if(partName.equals("Emp"))
{
((ChoosePrototypingLanguageAction)action).addEmp(selectedEmp);
}
}
else if(action instanceof DevelopPrototypeAction)
{
if(partName.equals("Developers"))
{
((DevelopPrototypeAction)action).addDevelopers(selectedEmp);
}
}
else if(action instanceof HaveCustomerEvaluatePrototypeAction)
{
if(partName.equals("EmployeeReps"))
{
((HaveCustomerEvaluatePrototypeAction)action).addEmployeeReps(selectedEmp);
}
}
else if(action instanceof SpecifyRequirementsAction)
{
if(partName.equals("Specifiers"))
{
((SpecifyRequirementsAction)action).addSpecifiers(selectedEmp);
}
}
else if(action instanceof DesignSystemAction)
{
if(partName.equals("Designer"))
{
((DesignSystemAction)action).addDesigner(selectedEmp);
}
}
else if(action instanceof ChooseImplementationLanguageAction)
{
if(partName.equals("Emp"))
{
((ChooseImplementationLanguageAction)action).addEmp(selectedEmp);
}
}
else if(action instanceof ImplementSystemAction)
{
if(partName.equals("Implementers"))
{
((ImplementSystemAction)action).addImplementers(selectedEmp);
}
}
else if(action instanceof DeliverFinalProductAction)
{
if(partName.equals("Emp"))
{
((DeliverFinalProductAction)action).addEmp(selectedEmp);
}
}
}
}

public void actionPerformed(ActionEvent evt)
{
Object source = evt.getSource();
if(source == cancelButton)
{
actionCancelled = true;
setVisible(false);
dispose();
}
else if(source == okButton)
{
Vector<JCheckBox> checkedBoxes = new Vector<JCheckBox>();
for(int i=0; i<checkBoxes.size(); i++)
{
JCheckBox tempCBox = checkBoxes.elementAt(i);
if(tempCBox.isSelected())
{
checkedBoxes.add(tempCBox);
}
}
if(checkedBoxes.size() < minNumParts)
{
JOptionPane.showMessageDialog(null, ("You must choose at least " + minNumParts + " participants"), "Invalid Input", JOptionPane.ERROR_MESSAGE);
}
else if(checkedBoxes.size() > maxNumParts)
{
JOptionPane.showMessageDialog(null, ("You may only choose at most " + maxNumParts + " participants"), "Invalid Input", JOptionPane.ERROR_MESSAGE);
}
else
{
for(int i=0; i<checkedBoxes.size(); i++)
{
JCheckBox checkedBox = checkedBoxes.elementAt(i);
String cBoxText = checkedBox.getText();
String objTypeName = cBoxText.substring(0, (cBoxText.indexOf('(') - 1));
String keyValStr = cBoxText.substring((cBoxText.indexOf('(') + 1), cBoxText.lastIndexOf(')'));

addParticipant(objTypeName, keyValStr);
}
setVisible(false);
dispose();
}
}
else if (source == checkAllButton) {
for (int i = 0; i < checkBoxes.size(); i++) {
checkBoxes.elementAt(i).setSelected(true);
}
}
else if (source == clearAllButton) {
for (int i = 0; i < checkBoxes.size(); i++) {
checkBoxes.elementAt(i).setSelected(false);
}
}
}

private void addParticipant(String objTypeName, String keyValStr)
{
if(objTypeName.equals("SoftwareEngineer"))
{
SoftwareEngineer a = state.getEmployeeStateRepository().getSoftwareEngineerStateRepository().get(keyValStr);
if(a != null)
{
if(action instanceof OutlineRequirementsWithCustomerAction)
{
if(partName.equals("RequirementsAnalysts"))
{
((OutlineRequirementsWithCustomerAction)action).addRequirementsAnalysts(a);
}
}
else if(action instanceof ChoosePrototypingLanguageAction)
{
if(partName.equals("Emp"))
{
((ChoosePrototypingLanguageAction)action).addEmp(a);
}
}
else if(action instanceof DevelopPrototypeAction)
{
if(partName.equals("Developers"))
{
((DevelopPrototypeAction)action).addDevelopers(a);
}
}
else if(action instanceof HaveCustomerEvaluatePrototypeAction)
{
if(partName.equals("EmployeeReps"))
{
((HaveCustomerEvaluatePrototypeAction)action).addEmployeeReps(a);
}
}
else if(action instanceof SpecifyRequirementsAction)
{
if(partName.equals("Specifiers"))
{
((SpecifyRequirementsAction)action).addSpecifiers(a);
}
}
else if(action instanceof DesignSystemAction)
{
if(partName.equals("Designer"))
{
((DesignSystemAction)action).addDesigner(a);
}
}
else if(action instanceof ChooseImplementationLanguageAction)
{
if(partName.equals("Emp"))
{
((ChooseImplementationLanguageAction)action).addEmp(a);
}
}
else if(action instanceof ImplementSystemAction)
{
if(partName.equals("Implementers"))
{
((ImplementSystemAction)action).addImplementers(a);
}
}
else if(action instanceof DeliverFinalProductAction)
{
if(partName.equals("Emp"))
{
((DeliverFinalProductAction)action).addEmp(a);
}
}
}
}
}

private void setMinAndMax()
{
if(action instanceof OutlineRequirementsWithCustomerAction)
{
if(partName.equals("RequirementsAnalysts"))
{
if(selectedEmp == null)
{
minNumParts = 5;
maxNumParts = 5;}
else
{
minNumParts = 5 - 1;
maxNumParts = 5 - 1;
}

}
else if(partName.equals("RequirementsDoc"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("CustomerRep"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof ChoosePrototypingLanguageAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Lang"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof DevelopPrototypeAction)
{
if(partName.equals("Developers"))
{
if(selectedEmp == null)
{
minNumParts = 5;
maxNumParts = 5;}
else
{
minNumParts = 5 - 1;
maxNumParts = 5 - 1;
}

}
else if(partName.equals("Prototype"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("RequirementsDoc"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Cust"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Language"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof HaveCustomerEvaluatePrototypeAction)
{
if(partName.equals("EmployeeReps"))
{
if(selectedEmp == null)
{
minNumParts = 5;
maxNumParts = 5;}
else
{
minNumParts = 5 - 1;
maxNumParts = 5 - 1;
}

}
else if(partName.equals("Requirements"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Prototype"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("CustomerRep"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof SpecifyRequirementsAction)
{
if(partName.equals("Specifiers"))
{
if(selectedEmp == null)
{
minNumParts = 5;
maxNumParts = 5;}
else
{
minNumParts = 5 - 1;
maxNumParts = 5 - 1;
}

}
else if(partName.equals("ReqDoc"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof DesignSystemAction)
{
if(partName.equals("Designer"))
{
if(selectedEmp == null)
{
minNumParts = 5;
maxNumParts = 5;}
else
{
minNumParts = 5 - 1;
maxNumParts = 5 - 1;
}

}
else if(partName.equals("Design"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedRequirements"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Prototype"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof ChooseImplementationLanguageAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Language"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof ImplementSystemAction)
{
if(partName.equals("Implementers"))
{
if(selectedEmp == null)
{
minNumParts = 5;
maxNumParts = 5;}
else
{
minNumParts = 5 - 1;
maxNumParts = 5 - 1;
}

}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedRequirements"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssoociatedDesign"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ImplementationLang"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Prototype"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof DeliverFinalProductAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Requirements"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof IncNumRequirementsNotEvaluatedAction)
{
if(partName.equals("Prototype"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof IncreaseNumRequirementsNotDesignedAction)
{
if(partName.equals("Design"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedReqDoc"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof IncreaseNumRequirementsNotDiscoveredAction)
{
if(partName.equals("Requirements"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof IncreaseNumRequirementsNotImplementedAction)
{
if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedRequirements"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof IncreaseNumRequirementsNotPrototypedAction)
{
if(partName.equals("Requirements"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof IncreaseNumRequirementsNotSpecifiedAction)
{
if(partName.equals("ReqDoc"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof NotifyCustomerAnxiousForInitialPrototypeAction)
{
if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 5;
maxNumParts = 5;}
else
{
minNumParts = 5 - 1;
maxNumParts = 5 - 1;
}

}
}
else if(action instanceof NotifyCustomerAnxiousForRevisedPrototypeAction)
{
if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 5;
maxNumParts = 5;}
else
{
minNumParts = 5 - 1;
maxNumParts = 5 - 1;
}

}
}
else if(action instanceof SameLangChosenForPrototypeAndCodeAction)
{
if(partName.equals("Language"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof SetCodeExtraErrorsNoDesAction)
{
if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedDesign"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof SetCodeExtraErrorsNoReqAction)
{
if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedRequirements"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof SetDesignExtraErrorsAction)
{
if(partName.equals("Design"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedRequirements"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof SetRequirementsDiscoveryModifierCapAction)
{
if(partName.equals("Prototype"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof SetRequirementsDiscoveryModifierNormalAction)
{
if(partName.equals("Prototype"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof SetRequirementsPcntErroneousNonZeroAction)
{
if(partName.equals("Requirements"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Prototype"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof SetRequirementsPcntErroneousZeroAction)
{
if(partName.equals("Requirements"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Prototype"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof UpdateArtifactsPercentCompleteAction)
{
if(partName.equals("Req"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Des"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof UpdateTimeUsedAction)
{
if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
}
else if(action instanceof SuggestedRequirementsOutliningPhaseAction)
{
if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
}
else if(action instanceof SuggestedPrototypingPhaseAction)
{
if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
}
else if(action instanceof SuggestedRequirementsPhaseAction)
{
if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
}
else if(action instanceof SuggestedDesignPhaseAction)
{
if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
}
else if(action instanceof SuggestedImplementationPhaseAction)
{
if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
}
}
public boolean actionCancelled()
{
return actionCancelled;
}

public class ExitListener extends WindowAdapter {
public void windowClosing(WindowEvent event) {
actionCancelled = true;
}
}
}
